SystemOrganization addCategory: #'AL-Http-Core'!
SystemOrganization addCategory: #'AL-Http-Endpoints'!
SystemOrganization addCategory: #'AL-Http-Exceptions'!
SystemOrganization addCategory: #'AL-Http-Protocol'!
SystemOrganization addCategory: #'AL-Http-Relays'!
SystemOrganization addCategory: #'AL-Http-Utilities'!
SystemOrganization addCategory: #'AL-Http-Values'!

Notification subclass: #ALStipulation
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Exceptions'!

!ALStipulation class methodsFor: 'signaling' stamp: 'cwp 1/25/2013 23:56'!
component: aComponent
	^ (self withComponent: aComponent) signal! !

!ALStipulation class methodsFor: 'instance creation' stamp: 'cwp 1/25/2013 23:56'!
withComponent: aComponent
	^ self basicNew initializeWithComponent: aComponent! !

!ALStipulation methodsFor: 'as yet unclassified' stamp: 'cwp 1/25/2013 23:55'!
component
	^ component! !

!ALStipulation methodsFor: 'as yet unclassified' stamp: 'cwp 1/25/2013 23:55'!
initializeWithComponent: aComponent
	self initialize.
	component := aComponent! !

!Collection methodsFor: '*al-http-converting' stamp: 'cwp 7/13/2012 13:08'!
asCookieSpecs
	^ ALCookieSpecs withAll: self! !

!Integer class methodsFor: '*al-http-dispatch' stamp: 'cwp 12/13/2012 13:51'!
parseWith: aParser
	^ aParser parseInteger! !

!String class methodsFor: '*al-http-dispatch' stamp: 'cwp 12/13/2012 13:00'!
parseWith: aParser
	^ aParser parseString! !

!String methodsFor: '*al-http-dispatch' stamp: 'cwp 7/13/2012 18:34'!
printWith: aPrinter
	aPrinter printString: self! !

Object subclass: #ALClient
	instanceVariableNames: 'host port in out handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Endpoints'!

!ALClient class methodsFor: 'instance creation' stamp: 'cwp 11/24/2012 21:31'!
host: aHostOrString
	^ aHostOrString isString
		ifTrue: [self host: aHostOrString port: 80]
		ifFalse: [self host: aHostOrString in: nil out: nil].! !

!ALClient class methodsFor: 'instance creation' stamp: 'cwp 11/24/2012 21:29'!
host: aHost in: aReadStream out: aWriteStream
	^ self basicNew
		initializeWithHost: aHost
		in: aReadStream
		out: aWriteStream! !

!ALClient class methodsFor: 'instance creation' stamp: 'cwp 11/24/2012 21:31'!
host: aString port: anInteger
	| host |
	host := ALHost name: aString port: anInteger.
	^ self host: host in: nil out: nil! !

!ALClient class methodsFor: 'instance creation' stamp: 'cwp 11/24/2012 21:33'!
host: aString port: anInteger in: aReadStream out: aWriteStream
	| host |
	host := ALHost name: aString port: anInteger.
	^ self host: host in: aReadStream out: aWriteStream! !

!ALClient methodsFor: 'connection' stamp: 'cwp 11/24/2012 21:39'!
connect
	self isConnected ifFalse:
		[| sock |
		Socket initializeNetwork.
		sock := Socket tcpCreateIfFail: [self error: 'Unable to create a socket'].
		sock connectToHostNamed: host name port: host port.
		in := sock reading.
		out := sock writing]! !

!ALClient methodsFor: 'connection' stamp: 'cwp 9/6/2011 16:32'!
disconnect
	in ifNotNil:
		[in close.
		in := nil].
	out ifNotNil:
		[out close.
		out := nil]! !

!ALClient methodsFor: 'public' stamp: 'cwp 9/6/2011 15:50'!
get: aPath
	| request response |
	request := ALRequest get: aPath.
	response := self sendRequest: request.
	^ response content! !

!ALClient methodsFor: 'public' stamp: 'cwp 10/24/2011 15:19'!
handleRequest: aRequest
	| parser response printer |
	self connect.
	printer := ALHttpPrinter on: out.
	parser := ALHttpParser on: in.
	printer printRequest: aRequest.
	response := parser parseResponse.
	response body body: [in reading].
	^ response! !

!ALClient methodsFor: 'accessing' stamp: 'cwp 9/4/2011 00:10'!
host
	^ host! !

!ALClient methodsFor: 'initialize-release' stamp: 'cwp 11/24/2012 21:34'!
initializeWithHost: aHost in: aReadStream out: aWriteStream
	self initialize.
	host := aHost.
	in := aReadStream.
	out := aWriteStream.
	handler := self! !

!ALClient methodsFor: 'connection' stamp: 'cwp 9/6/2011 17:03'!
isConnected
	in ifNil: [^ false].
	out ifNil: [^ false].
	^ true! !

!ALClient methodsFor: 'public' stamp: 'cwp 11/24/2012 21:38'!
sendRequest: aRequest
	aRequest host: host.
	^ handler handleRequest: aRequest! !

Object subclass: #ALEtag
	instanceVariableNames: 'tag isWeak'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Values'!

!ALEtag class methodsFor: 'dispatch' stamp: 'cwp 11/30/2012 19:46'!
parseWith: aParser
	^ aParser parseEtag! !

!ALEtag class methodsFor: 'instance creation' stamp: 'cwp 11/29/2012 16:34'!
strong: aString
	^ self tag: aString weak: false! !

!ALEtag class methodsFor: 'instance creation' stamp: 'cwp 11/29/2012 16:34'!
tag: aString weak: aBoolean
	^ self basicNew initializeWithTag: aString weak: aBoolean! !

!ALEtag class methodsFor: 'instance creation' stamp: 'cwp 11/29/2012 16:34'!
weak: aString
	^ self tag: aString weak: true! !

!ALEtag methodsFor: 'comparing' stamp: 'cwp 1/12/2013 19:31'!
= other
	 ^ self species = other species
		and: [self tag = other tag
			and: [self isStrong = other isStrong]]! !

!ALEtag methodsFor: 'comparing' stamp: 'cwp 1/12/2013 19:32'!
hash
	^ tag hash bitXor: isWeak hash! !

!ALEtag methodsFor: 'initialization' stamp: 'cwp 11/29/2012 16:33'!
initializeWithTag: aString weak: aBoolean
	self initialize.
	tag := aString.
	isWeak := aBoolean! !

!ALEtag methodsFor: 'accessing' stamp: 'cwp 11/30/2012 20:18'!
isStrong
	^ isWeak not! !

!ALEtag methodsFor: 'accessing' stamp: 'cwp 11/29/2012 16:33'!
isWeak
	^ isWeak! !

!ALEtag methodsFor: 'dispatch' stamp: 'cwp 11/29/2012 17:00'!
printWith: aPrinter
	aPrinter printEtag: self! !

!ALEtag methodsFor: 'accessing' stamp: 'cwp 11/29/2012 16:33'!
tag
	^ tag! !

Object subclass: #ALFormDataParser
	instanceVariableNames: 'in out'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Protocol'!

!ALFormDataParser class methodsFor: 'as yet unclassified' stamp: 'cwp 10/8/2012 15:02'!
in: aReadStream out: aWriteStream
	^ self basicNew initializeWithIn: aReadStream out: aWriteStream! !

!ALFormDataParser class methodsFor: 'as yet unclassified' stamp: 'cwp 10/8/2012 15:04'!
parse: aReadable
	^ (self in: aReadable reading percentDecoding out: Array new writing) parse! !

!ALFormDataParser methodsFor: 'as yet unclassified' stamp: 'cwp 9/24/2011 15:16'!
assert: aCharacter
	in get = aCharacter ifFalse: 
		[ALParseError signal: 'Expected ', aCharacter asString]! !

!ALFormDataParser methodsFor: 'as yet unclassified' stamp: 'cwp 10/8/2012 15:03'!
initializeWithIn: aReadStream out: aWriteStream
	self initialize.
	in := aReadStream.
	out := aWriteStream.! !

!ALFormDataParser methodsFor: 'as yet unclassified' stamp: 'cwp 10/8/2012 15:05'!
parse
	[[out put: self parseAssociation.
	self assert: $& ] repeat ]
		on: Incomplete
		do: [ :ignore |  ].
	^ out conclusion! !

!ALFormDataParser methodsFor: 'as yet unclassified' stamp: 'cwp 9/24/2011 14:53'!
parseAssociation
	| key value |
	key := in get.
	self assert: $=.
	value := in get.
	^ key -> value! !

Object subclass: #ALHost
	instanceVariableNames: 'name port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Values'!

!ALHost class methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2011 14:34'!
name: aString
	^ self name: aString port: nil! !

!ALHost class methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2011 14:00'!
name: aString port: anInteger
	^ self basicNew initializeWithName: aString port: anInteger! !

!ALHost class methodsFor: 'dispatch' stamp: 'cwp 10/25/2011 14:05'!
parseWith: aParser
	^ aParser parseHost! !

!ALHost methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2011 14:01'!
initializeWithName: aString port: anInteger
	self initialize.
	name := aString.
	port := anInteger! !

!ALHost methodsFor: 'accessing' stamp: 'cwp 10/25/2011 14:02'!
name
	^ name! !

!ALHost methodsFor: 'accessing' stamp: 'cwp 10/25/2011 14:34'!
port
	^ port ! !

!ALHost methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2011 14:36'!
portDo: aBlock
	port ifNotNil: [aBlock value: port]! !

!ALHost methodsFor: 'dispatch' stamp: 'cwp 10/25/2011 14:35'!
printWith: aPrinter
	aPrinter printHost: self! !

Object subclass: #ALHttpGenerator
	instanceVariableNames: 'class category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Utilities'!

!ALHttpGenerator class methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2012 13:50'!
generate
	^ self new generate! !

!ALHttpGenerator methodsFor: 'generating' stamp: 'cwp 12/9/2012 19:26'!
category: aString do: aBlock
	| tmp |
	tmp := category.
	[category := aString.
	aBlock value]
		ensure: [category := tmp]! !

!ALHttpGenerator methodsFor: 'generating' stamp: 'cwp 12/9/2012 19:25'!
class: aClass do: aBlock
	| tmp |
	tmp := class.
	[class := aClass.
	aBlock value]
		ensure: [class := tmp]! !

!ALHttpGenerator methodsFor: 'generating' stamp: 'cwp 12/9/2012 19:45'!
clearExistingMethods
	(class organization listAtCategoryNamed: category) do:
		[:selector | class removeSelector: selector]! !

!ALHttpGenerator methodsFor: 'generating' stamp: 'cwp 12/9/2012 21:00'!
compile: aString
	| selector |
	selector := Parser new parseSelector: aString.
	(class organization categoryOfElement: selector) = category ifFalse:
		[class compile: aString classified: category]! !

!ALHttpGenerator methodsFor: 'specs' stamp: 'cwp 12/8/2012 21:28'!
connectionValues
	^ #('close' 'keep-alive')! !

!ALHttpGenerator methodsFor: 'specs' stamp: 'cwp 12/8/2012 21:17'!
entityHeaders
	^ #(
		('Allow')
		('Content-Encoding')
		('Content-Language')
		('Content-Length' #Integer)
		('Content-Location')
		('Content-MD5')
		('Content-Range' #Interval)
		('Content-Type' #ALContentType)
		('Expires' DateAndTime)
		('Last-Modified' DateAndTime)
	)! !

!ALHttpGenerator methodsFor: 'specs' stamp: 'cwp 12/8/2012 22:14'!
generalHeaders
	^ #(
		('Cache-Control')
		('Connection')
		('Date' #DateAndTime)
		('Pragma')
		('Trailer')
		('Transfer-Encoding')
		('Upgrade')
		('Via')
		('Warning')
	)! !

!ALHttpGenerator methodsFor: 'generating' stamp: 'cwp 12/13/2012 13:50'!
generate
	self generateMessage.
	self generateRequest.
	self generateResponse.
	self generateEntity.! !

!ALHttpGenerator methodsFor: 'generating' stamp: 'cwp 12/30/2012 11:37'!
generateEntity
	| ent |
	ent := self entityHeaders.
	self class: ALHttpEntity do:
		[self category: 'headers - getting' do:
			[self clearExistingMethods.
			ent do: [:ea | self compile: (self sourceForGetter: ea)]].
		self category: 'headers - setting' do:
			[self clearExistingMethods.
			ent do: [:ea | self compile: (self sourceForSetter: ea)]].
		self category: 'headers - testing' do:
			[self clearExistingMethods.
			ent do: [:ea | self compile: (self sourceForTester: ea)]]]! !

!ALHttpGenerator methodsFor: 'generating' stamp: 'cwp 12/13/2012 13:37'!
generateMessage
	| ent gen |
	ent := self entityHeaders.
	gen := self generalHeaders.
	self class: ALHttpMessage do: 
		[self category: 'headers - getting' do: 
			[self clearExistingMethods.
			ent do: [:ea | self compile: (self sourceForBodyGetter: ea)].
			gen do: [:ea | self compile: (self sourceForGetter: ea)]].
		self category: 'headers - setting' do:
			[self clearExistingMethods.
			ent do: [:ea | self compile: (self sourceForBodySetter: ea)].
			gen do: [:ea | self compile: (self sourceForSetter: ea)]].
		self category: 'headers - testing' do:
			[self clearExistingMethods.
			ent do: [:ea | self compile: (self sourceForBodyTester: ea)].
			gen do: [:ea | self compile: (self sourceForTester: ea)]]]
					! !

!ALHttpGenerator methodsFor: 'generating' stamp: 'cwp 12/13/2012 13:41'!
generateRequest
	| met req |
	req := self requestHeaders.
	met := self methods.
	self class: ALRequest do:
		[self category: 'headers - getting' do:
			[self clearExistingMethods.
			req do: [:ea | self compile: (self sourceForGetter: ea)]].
		self category: 'headers - setting' do: 
			[self clearExistingMethods.
			req do: [:ea | self compile: (self sourceForSetter: ea)]].
		self category: 'headers - testing' do: 
			[self clearExistingMethods.
			req do: [:ea | self compile: (self sourceForTester: ea)]].
		self category: 'methods - testing' do:
			[self clearExistingMethods.
			met do: [:ea | self compile: (self sourceForIsMethod: ea)]]].! !

!ALHttpGenerator methodsFor: 'generating' stamp: 'cwp 12/13/2012 13:45'!
generateResponse
	| res |
	res := self responseHeaders.
	self class: ALResponse do:
		[self category: 'headers - getting' do:
			[self clearExistingMethods.
			res do: [:ea | self compile: (self sourceForGetter: ea)]].
		self category: 'headers - setting' do:
			[self clearExistingMethods.
			res do: [:ea | self compile: (self sourceForSetter: ea)]].
		self category: 'headers - testing' do:
			[self clearExistingMethods.
			res do: [:ea | self compile: (self sourceForTester: ea)]]]! !

!ALHttpGenerator methodsFor: 'source code' stamp: 'cwp 12/9/2012 21:02'!
getterForHeader: aString
	| in out ch |
	out := String new writing.
	in := aString reading.
	[[ch := in get.
	ch isAlphaNumeric ifTrue: [out put: ch asLowercase].
	ch isUppercase] whileTrue]
		on: Incomplete
		do: [:nothing].
	out write: (in selecting: [:ea | ea isAlphaNumeric]).
	^ out conclusion
		! !

!ALHttpGenerator methodsFor: 'specs' stamp: 'cwp 12/8/2012 21:31'!
methods
	^ #(
		'OPTIONS'
		'GET'
		'HEAD'
		'POST'
		'PUT'
		'DELETE'
		'TRACE'
		'CONNECT'
	)! !

!ALHttpGenerator methodsFor: 'specs' stamp: 'cwp 12/25/2012 11:49'!
requestHeaders
	^ #(
		('Accept' #ALContentTypes)
		('Accept-Charset')
		('Accept-Encoding')
		('Accept-Language')
		('Authorization')
		('Cookie' #ALCookieValues)
		('Expect')
		('From')
		('Host' #ALHost)
		('If-Match' #ALEtag)
		('If-Modified-Since' #DateAndTime)
		('If-None-Match' #ALEtag)
		('If-Range' #Interval)
		('If-Unmodified-Since' #DateAndTime)
		('Max-Forwards')
		('Proxy-Authorization')
		('Range')
		('Referer' #ALUrl)
		('TE')
		('User-Agent')
	)
! !

!ALHttpGenerator methodsFor: 'specs' stamp: 'cwp 12/25/2012 11:49'!
responseHeaders
	^ #(
		('Accept-Ranges')
		('Age')
		('ETag' #ALEtag)
		('Location' #ALUrl)
		('Proxy-Authenticate')
		('Retry-After')
		('Server')
		('Set-Cookie' #ALCookieSpecs)
		('Vary' #ALStrings)
		('WWW-Authenticate')
	)! !

!ALHttpGenerator methodsFor: 'source code' stamp: 'cwp 12/8/2012 22:28'!
setterForHeader: aString
	^ (self getterForHeader: aString), ':'! !

!ALHttpGenerator methodsFor: 'source code' stamp: 'cwp 12/13/2012 13:27'!
sourceForBodyGetter: row
	| selector |
	selector := (self getterForHeader: row first).
	^ String new writing
		write: selector;
		cr;
		tab;
		write: '^ body ';
		write: selector;
		cr;
		conclusion! !

!ALHttpGenerator methodsFor: 'source code' stamp: 'cwp 12/13/2012 13:28'!
sourceForBodySetter: row
	| selector |
	selector := self setterForHeader: row first.
	^ String new writing
		write: selector;
		write: ' anObject';
		cr;
		tab;
		write: '^ body ';
		write: selector;
		write: ' anObject ';
		cr;
		conclusion! !

!ALHttpGenerator methodsFor: 'source code' stamp: 'cwp 12/13/2012 13:28'!
sourceForBodyTester: row
	| selector |
	selector := 'has', (self getterForHeader: row first) capitalized.
	^ String new writing
		write: selector; 
		cr;
		tab; 
		write: '^ body ';
		write: selector;
		cr;
		conclusion! !

!ALHttpGenerator methodsFor: 'source code' stamp: 'cwp 12/8/2012 22:49'!
sourceForGetter: row
	| className header selector |
	header := row first.
	className := row at: 2 ifAbsent: 'String'.
	selector := self getterForHeader: header.
	^ String new writing
		write: selector;cr; tab;
		write: '^ self parseHeader: ''';
		write: header;
		write: ''' as: ';
		write: className;
		conclusion! !

!ALHttpGenerator methodsFor: 'source code' stamp: 'cwp 12/9/2012 19:23'!
sourceForIsMethod: method
	^ String new writing
		write: 'isMethod';
		write: method asLowercase capitalized;
		cr; tab;
		write: '^ method = ''';
		write: method;
		put: $';
		cr;
		conclusion! !

!ALHttpGenerator methodsFor: 'source code' stamp: 'cwp 12/9/2012 01:30'!
sourceForSetter: row
	| className header selector argument |
	header := row first.
	className := row at: 2 ifAbsent: 'String'.
	selector := self setterForHeader: header.
	argument := (className first isVowel ifTrue: ['an'] ifFalse: ['a']), className.
	^ String new writing
		write: selector; 
		space;
		write: argument; cr; tab;
		write: 'headers at: ''';
		write: header;
		write: ''' put: ';
		write: argument; cr;
		conclusion! !

!ALHttpGenerator methodsFor: 'source code' stamp: 'cwp 12/13/2012 13:14'!
sourceForTester: row
	| header |
	header := row first.
	^ String new writing
		write: 'has';
		write: (self getterForHeader: header) capitalized; cr; 
		tab; write: '^ headers includesKey: ''';
		write: header;
		put: $';
		cr;
		conclusion! !

Object subclass: #ALHttpInterpreter
	instanceVariableNames: ''
	classVariableNames: 'CarriageReturn Colon Comma Digits Equals LineFeed Months Semicolon Slash Space Token Version'
	poolDictionaries: ''
	category: 'AL-Http-Protocol'!

!ALHttpInterpreter class methodsFor: 'as yet unclassified' stamp: 'cwp 12/6/2012 16:34'!
initialize
	"Initialize character classes with their ASCII values"

	CarriageReturn := 13.
	Colon := 58.
	Comma := 44.
	Equals := 61.
	LineFeed := 10.
	Semicolon := 59.
	Slash := 47.
	Space := 32.
	Digits := #[48 49 50 51 52 53 54 55 56 57] asIdentitySet.	
	Version := Digits copyWith: 46.
	Token := #[33 35 36 37 38 39 42 43 45 46 48 49 50 51 52 53 54 55 56 57 
				65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 
				85 86 87 88 89 90 94 95 96 97 98 99 100 101 102 103 104 105 
				106 107 108 109 110 111 112 113 114 115 116 117 118 119 120
				121 122 124 126] asIdentitySet.
	
	Months := #('Jan' 'Feb' 'Mar' 'Apr' 'May' 'Jun' 'Jul' 'Aug' 'Sep' 'Oct' 'Nov' 'Dec')
! !

!ALHttpInterpreter methodsFor: 'parsing' stamp: 'cwp 12/6/2012 16:24'!
localOffset
	^ Duration minutes: Locale current offsetLocalToUTC! !

ALHttpInterpreter subclass: #ALHttpParser
	instanceVariableNames: 'in ch result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Protocol'!

!ALHttpParser class methodsFor: 'as yet unclassified' stamp: 'cwp 9/15/2011 15:44'!
on: aReadStream
	^ self basicNew initializeWithStream: aReadStream! !

!ALHttpParser class methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2011 13:21'!
parse: aReadable as: aClass
	^ (self on: aReadable reading) parse: aClass! !

!ALHttpParser class methodsFor: 'parsing' stamp: 'cwp 7/11/2012 22:04'!
parseCookieValues: aReadStream
	^ (self on: aReadStream) parseCookieValues! !

!ALHttpParser methodsFor: 'asserting' stamp: 'cwp 9/15/2011 15:41'!
assert: aByte
	ch = aByte ifFalse: [ALMalformedRequest signal].
	ch := nil.! !

!ALHttpParser methodsFor: 'asserting' stamp: 'cwp 9/15/2011 15:41'!
assertCrLf
	"Character cr asciiValue = 13"
	"Character lf acsiiValue = 10"
	
	self assert: 13.
	self next: 10.
! !

!ALHttpParser methodsFor: 'asserting' stamp: 'cwp 9/15/2011 15:41'!
assertSpace
	"Character space asciiValue = 32"
	self assert: 32.
! !

!ALHttpParser methodsFor: 'initialize-release' stamp: 'cwp 9/15/2011 15:35'!
initializeWithStream: aReadStream
	in := aReadStream
	! !

!ALHttpParser methodsFor: 'asserting' stamp: 'cwp 9/15/2011 15:41'!
next: expected
	| actual |
	actual := in get.
	actual = expected ifFalse: [ALMalformedRequest signal]! !

!ALHttpParser methodsFor: 'dispatch' stamp: 'cwp 10/24/2011 15:02'!
parse: aClass
	^ aClass parseWith: self! !

!ALHttpParser methodsFor: 'parsing' stamp: 'cwp 12/6/2012 16:47'!
parseAsctime
	self shouldBeImplemented! !

!ALHttpParser methodsFor: 'dispatch' stamp: 'cwp 10/24/2011 15:01'!
parseContentType
	result := self parseTypeSubtype.
	self parseParameters.
	^ result! !

!ALHttpParser methodsFor: 'dispatch' stamp: 'cwp 12/19/2012 22:12'!
parseContentTypes
	| out |
	out := (ALContentTypes new: 1) writing.
	[out put: self parseContentType.
	[ch = Comma] whileTrue: 
		[ch := nil.
		out put: self parseContentType]]
			on: Incomplete
			do: [:nothing].
	^ out conclusion ! !

!ALHttpParser methodsFor: 'parsing' stamp: 'cwp 7/12/2012 22:54'!
parseCookieSpec
	| name value |
	name := self parseToken.
	self assert: Equals.
	value := self parseTokenUntilSemicolon.
	result := ALCookie name: name value: value.
	self parseParameters.
	^ result! !

!ALHttpParser methodsFor: 'dispatch' stamp: 'cwp 7/12/2012 23:20'!
parseCookieSpecs
	"Parsing cookies on the client side is... complex. See RFC 6265."
	self shouldBeImplemented.
"	out := (Array new: 1) writing.
	[out put: self parseCookieSpec.
	[true] whileTrue: 
		[self assert: Comma.
		self next: Space.
		out put: self parseCookieSpec]]
			on: Incomplete
			do: [:nothing].
	^ out conclusion"! !

!ALHttpParser methodsFor: 'parsing' stamp: 'cwp 7/11/2012 22:30'!
parseCookieValue
	| name value |
	name := self parseToken.
	self assert: Equals.
	value := self parseTokenUntilSemicolon.
	^ ALCookie name: name value: value! !

!ALHttpParser methodsFor: 'dispatch' stamp: 'cwp 7/11/2012 22:25'!
parseCookieValues
	| out |
	out := (Array new: 1) writing.
	[out put: self parseCookieValue.
	[true] whileTrue: 
		[self assert: Semicolon.
		self next: Space.
		out put: self parseCookieValue]]
			on: Incomplete
			do: [:nothing].
	^ out conclusion ! !

!ALHttpParser methodsFor: 'dispatch' stamp: 'cwp 12/6/2012 16:26'!
parseDateTime
	in ++ 3.
	ch := in get.
	ch = Comma ifTrue: [^ self parseRfc1123].
	ch = Space ifTrue: [^ self parseAsctime].
	^ self parseRfc850.! !

!ALHttpParser methodsFor: 'dispatch' stamp: 'cwp 11/30/2012 20:17'!
parseEtag
	| out weak |
	out := String new writing.
	weak := false.
	ch := in get.
	ch = 87 "W" ifTrue:
		[weak := true.
		self next: 47. "/"
		ch := in get].
	self assert: 34. "double-quote"
	[(ch := in get) = 34] whileFalse: [out put: (Character value: ch)].
	^ ALEtag tag: out conclusion weak: weak.! !

!ALHttpParser methodsFor: 'parsing' stamp: 'cwp 10/24/2011 15:02'!
parseFieldValue
	"Character tab asciiValue = 9"
	"Character space asciiValue = 32"
	"Character cr asciivalue = 13"
	"Character lf asciiValue = 10"
	"For now, we ignore the possibility of line folding"

	| out byte |
	[byte := in get.
	byte = 32 or: [byte = 9]] whileTrue.
	out := ByteArray new writing.
	out put: byte.
	[(byte := in get) = CarriageReturn] whileFalse: [out put: byte].
	self next: LineFeed.
	^ out conclusion! !

!ALHttpParser methodsFor: 'parsing' stamp: 'cwp 12/13/2012 12:53'!
parseHeaders
	
	| name value |
	[name := self parseToken.
	name isEmpty ifTrue: [^ self assertCrLf].
	self assert: Colon.
	value := self parseFieldValue.
	result headerAt: name put: value]
		repeat
	
! !

!ALHttpParser methodsFor: 'dispatch' stamp: 'cwp 10/25/2011 14:10'!
parseHost
	| name port token |
	name := self parseToken.
	ch = Colon ifTrue:
		[token := self parseToken.
		port := XTNumberParser 
			parse: token asString 
			base: 10 
			ifFail: [ALParseError signal: 'Expected a port number']].
	^ ALHost name: name port: port! !

!ALHttpParser methodsFor: 'dispatch' stamp: 'cwp 12/13/2012 13:53'!
parseInteger
	| ascii |
	ascii := in encoding: #ascii.
	^ XTNumberParser 
		parse: ascii 
		base: 10 
		ifFail: [ALMalformedRequest signal]! !

!ALHttpParser methodsFor: 'parsing' stamp: 'cwp 12/6/2012 16:29'!
parseInteger: anInteger ifFail: error
	| bytes ascii |
	bytes := in read: anInteger.
	ascii := bytes reading encoding: #ascii.
	^ XTNumberParser parse: ascii base: 10 ifFail: error! !

!ALHttpParser methodsFor: 'parsing' stamp: 'cwp 10/24/2011 15:02'!
parseMethod
	| method |
	method := self parseToken.
	ch ifNil: [Incomplete signal].
	self assertSpace.
	^ method! !

!ALHttpParser methodsFor: 'parsing' stamp: 'cwp 12/19/2012 22:04'!
parseParameter
 
	| attribute value |
	in available = 0 ifTrue: [^ false].
	ch = Comma ifTrue: [^ false].
	self assert: Semicolon.
	self skip: Space.
	attribute := self parseToken.
	self assert: Equals.
	value := self parseToken.
	result parameter: attribute value: value.
	^ true! !

!ALHttpParser methodsFor: 'parsing' stamp: 'cwp 10/24/2011 15:01'!
parseParameters
	
	[[self parseParameter] whileTrue]
		on: Incomplete
		do: [:error]! !

!ALHttpParser methodsFor: 'parsing' stamp: 'cwp 10/24/2011 15:02'!
parsePath

	| out path |
	path := ALPath root.
	ch := in get. 
	ch = Slash ifFalse: [self error].

	out := String new writing.
	[(ch := in get) = Space] whileFalse:
		[ch = Slash
			ifFalse: [out put: (Character value: ch)]
			ifTrue: 
				[path := path / out conclusion.
				out := String new writing]].
	path := path / out conclusion.
	self assertSpace.
	^ path
			! !

!ALHttpParser methodsFor: 'parsing' stamp: 'cwp 10/24/2011 15:02'!
parseReason
	^ (in ending: 13) rest asString! !

!ALHttpParser methodsFor: 'dispatch' stamp: 'cwp 10/24/2011 15:02'!
parseRequest
	result := self parseRequestLine.
	self parseHeaders.
	^ result! !

!ALHttpParser methodsFor: 'parsing' stamp: 'cwp 12/30/2012 11:37'!
parseRequestLine
	| version path method entity |
	method := self parseMethod.
	path := self parseUrl.
	version := self parseVersion.
	self assertCrLf.
	entity := ALHttpEntity empty.
	^ ALRequest method: method url: path version: version body: entity.
	! !

!ALHttpParser methodsFor: 'dispatch' stamp: 'cwp 10/24/2011 15:02'!
parseResponse
	result := self parseStatusLine.
	self parseHeaders.
	^ result! !

!ALHttpParser methodsFor: 'parsing' stamp: 'cwp 12/6/2012 16:45'!
parseRfc1123
	| day error month monthName hour minute second tz year |
	error := [ ALMalformedRequest signal ].
	in get = Space ifFalse: error.
	day := self parseInteger: 2 ifFail: error.
	in get = Space ifFalse: error.
	monthName := (in read: 3) asString.
	month := (Months indexOf: monthName).
	in get = Space ifFalse: error.
	year := self parseInteger: 4 ifFail: error.
	in get = Space ifFalse: error.
	hour := self parseInteger: 2 ifFail: error.
	in get = Colon ifFalse: error.
	minute := self parseInteger: 2 ifFail: error.
	in get = Colon ifFalse: error.
	second := self parseInteger: 2 ifFail: error.
	in get = Space ifFalse: error.
	tz := in read: 3.
	tz = 'GMT' asByteArray ifFalse: error.
	^ (DateAndTime
		year: year
		month: month
		day: day
		hour: hour
		minute: minute
		second: second) + self localOffset! !

!ALHttpParser methodsFor: 'parsing' stamp: 'cwp 12/6/2012 16:48'!
parseRfc850
	self shouldBeImplemented! !

!ALHttpParser methodsFor: 'parsing' stamp: 'cwp 10/24/2011 15:02'!
parseStatus
	| digits |
	digits := self readAll: Digits.
	^ Integer readFrom: digits readStream! !

!ALHttpParser methodsFor: 'parsing' stamp: 'cwp 12/30/2012 11:37'!
parseStatusLine
	| version reason status body |
	version := self parseVersion.
	self assert: Space.
	status := self parseStatus.
	self assert: Space.
	reason := self parseReason.
	self next: LineFeed.
	body := ALHttpEntity empty.
	^ ALResponse status: status reason: reason version: version body: body! !

!ALHttpParser methodsFor: 'dispatch' stamp: 'cwp 12/13/2012 13:02'!
parseString
	| ascii |
	ascii := in encoding: #ascii.
	^ ascii rest! !

!ALHttpParser methodsFor: 'dispatch' stamp: 'cwp 12/19/2012 23:10'!
parseStrings
	| out |
	out := (ALStrings new: 1) writing.
	[out put: self parseToken.
	[ch = Comma] whileTrue: 
		[ch := nil.
		self skip: Space.
		out put: self parseToken]]
			on: Incomplete
			do: [:nothing].
	^ out conclusion ! !

!ALHttpParser methodsFor: 'parsing' stamp: 'cwp 12/19/2012 22:09'!
parseToken

	|  out |
	out := ByteArray new writing.
	ch ifNotNil: [(Token includes: ch) ifTrue: [out put: ch]].
	[[Token includes: (ch := in get)] whileTrue: [out put: ch]]
		on: Incomplete
		do: [:ignore | ch := nil].
	^ out conclusion asString! !

!ALHttpParser methodsFor: 'parsing' stamp: 'cwp 7/11/2012 22:35'!
parseTokenUntilSemicolon

	|  out |
	out := ByteArray new writing.
	ch ifNotNil: [Semicolon = ch ifFalse: [out put: ch]].
	[[Semicolon = (ch := in get)] whileFalse: [out put: ch]]
		on: Incomplete
		do: [:error | ch := Semicolon].
	^ out conclusion asString! !

!ALHttpParser methodsFor: 'parsing' stamp: 'cwp 10/24/2011 15:01'!
parseTypeSubtype

	| type subtype |
	type := self parseToken.
	self assert: Slash.
	subtype := self parseToken.
	^ ALContentType type: type subtype: subtype! !

!ALHttpParser methodsFor: 'parsing' stamp: 'cwp 10/4/2012 14:53'!
parseUrl
	| rs ws |
	rs := ((in ending: 32) encoding: #ascii) percentDecoding.
	ws := ALUrl writing.
	ws write:  rs.
	^ ws conclusion! !

!ALHttpParser methodsFor: 'parsing' stamp: 'cwp 10/24/2011 15:03'!
parseVersion
	| version |
	self next: $H asciiValue.
	self next: $T asciiValue.
	self next: $T asciiValue.
	self next: $P asciiValue.
	self next: Slash.
	version := self readAll: Version.
	^ version! !

!ALHttpParser methodsFor: 'parsing' stamp: 'cwp 9/15/2011 15:38'!
readAll: aByteArray
	| out |
	out := ByteArray new writing.
	[aByteArray includes: (ch := in get)] whileTrue: [out put: ch].
	^ out conclusion asString! !

!ALHttpParser methodsFor: 'parsing' stamp: 'cwp 12/19/2012 23:11'!
skip: ascii
	ch := in get.
	[ch == ascii] whileTrue: 
		[ch := in get]! !

ALHttpInterpreter subclass: #ALHttpPrinter
	instanceVariableNames: 'out message ascii'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Protocol'!

!ALHttpPrinter class methodsFor: 'system primitives' stamp: 'cwp 12/4/2012 22:48'!
localSecondsClockWithOffset
	<primitive: 'primitiveLocalSecondsClockWithOffset' module: 'TimeFunctions'>
	^ nil! !

!ALHttpPrinter class methodsFor: 'instance creation' stamp: 'cwp 4/23/2011 15:54'!
on: aWriteStream
	^ self basicNew initializeWithStream: aWriteStream ! !

!ALHttpPrinter class methodsFor: 'system primitives' stamp: 'cwp 12/4/2012 22:47'!
posixTimeAndLocalOffset
	<primitive: 'primitivePosixTimeAndLocalOffset' module: 'TimeFunctions'>
	^ nil! !

!ALHttpPrinter class methodsFor: 'printing' stamp: 'cwp 12/19/2012 22:40'!
print: aValue
	| out |
	out := ByteArray new writing.
	self print: aValue on: out.
	^ out conclusion! !

!ALHttpPrinter class methodsFor: 'printing' stamp: 'cwp 11/3/2012 13:46'!
print: aMessage on: aStream
	| printer |
	printer := self on: aStream.
	printer print: aMessage! !

!ALHttpPrinter class methodsFor: 'system primitives' stamp: 'cwp 12/4/2012 22:45'!
utcWithOffset
	<primitive: 'primitiveUtcWithOffset'>
	^nil! !

!ALHttpPrinter methodsFor: 'printing' stamp: 'cwp 9/4/2011 23:20'!
crlf

	out
		cr;
		lf! !

!ALHttpPrinter methodsFor: 'initialize-release' stamp: 'cwp 10/25/2011 14:54'!
initializeWithStream: aWriteStream
	out := aWriteStream.
	ascii := aWriteStream encoding: #ascii.
	ascii setLineEndTransparent ! !

!ALHttpPrinter methodsFor: 'dispatch' stamp: 'cwp 10/19/2011 19:36'!
print: aMessage
	aMessage printWith: self! !

!ALHttpPrinter methodsFor: 'dispatch' stamp: 'cwp 10/25/2011 14:22'!
printBytes: aByteArray 
	out write: aByteArray! !

!ALHttpPrinter methodsFor: 'dispatch' stamp: 'cwp 7/12/2012 15:42'!
printCommaSequence: aCollection
	aCollection
		do: [:ea | ea printWith: self]
		separatedBy: [out write: ', ']! !

!ALHttpPrinter methodsFor: 'dispatch' stamp: 'cwp 7/12/2012 15:47'!
printContentType: aContentType
	out
		write: aContentType type;
		put: Slash;
		write: aContentType subtype.
	self printParametersOf: aContentType! !

!ALHttpPrinter methodsFor: 'printing' stamp: 'cwp 12/25/2012 12:39'!
printCookie: aCookie 
	out 
		write: aCookie name;
		put: $= asciiValue;
		write: aCookie value.
	self printParametersOf: aCookie! !

!ALHttpPrinter methodsFor: 'dispatch' stamp: 'cwp 12/6/2012 16:25'!
printDateTime: aDateAndTime
	| utc numbers |
	utc := aDateAndTime - self localOffset.
	ascii := out encoding: #ascii.
	numbers := XTNumberPrinter new.
	numbers padTo: 2 with: $0.
	out
		write: aDateAndTime dayOfWeekAbbreviation;
		write: Comma;
		write: Space.
	numbers print: utc dayOfMonth on: ascii.
	out
		write: Space;
		write: utc monthAbbreviation;
		write: Space.
	numbers print: utc year on: ascii.
	out write: Space.
	numbers print: utc hour24 on: ascii.
	out write: Colon.
	numbers print: utc minutes on: ascii.
	out write: Colon.
	numbers print: utc seconds on: ascii.
	out write: Space.
	out write: 'GMT'! !

!ALHttpPrinter methodsFor: 'dispatch' stamp: 'cwp 11/30/2012 20:48'!
printEtag: anEtag
	anEtag isWeak ifTrue: [out write: 'W/'].
	out 
		put: $" asciiValue;
		write: anEtag tag;
		put: $" asciiValue! !

!ALHttpPrinter methodsFor: 'printing' stamp: 'cwp 10/25/2011 14:50'!
printHeader: name value: value
	out
		write: name;
		put: Colon;
		put: Space.
	self print: value.
	out
		cr;
		lf! !

!ALHttpPrinter methodsFor: 'printing' stamp: 'cwp 12/13/2012 12:51'!
printHeaders
	message headersDo: [ :name :value | self printHeader: name value: value ].
	out
		cr;
		lf! !

!ALHttpPrinter methodsFor: 'dispatch' stamp: 'cwp 10/25/2011 14:52'!
printHost: aHost
	out write: aHost name.
	aHost portDo:
		[:port |
		out put: Colon.
		ascii print: port]! !

!ALHttpPrinter methodsFor: 'dispatch' stamp: 'cwp 10/25/2011 15:00'!
printNumber: aNumber
	ascii print: aNumber! !

!ALHttpPrinter methodsFor: 'printing' stamp: 'cwp 7/12/2012 15:47'!
printParametersOf: aContentType
	aContentType
		parametersDo: [ :attribute :value | 
			out
				put: Semicolon;
				put: Space;
				write: attribute;
				put: Equals;
				write: value ]! !

!ALHttpPrinter methodsFor: 'dispatch' stamp: 'cwp 12/22/2012 23:16'!
printPath: aPath
	aPath streamingPrintOn: out! !

!ALHttpPrinter methodsFor: 'printing' stamp: 'cwp 9/6/2011 16:39'!
printRequest
	self printRequestLine.
	self printHeaders.
	out flush! !

!ALHttpPrinter methodsFor: 'dispatch' stamp: 'cwp 9/4/2011 01:30'!
printRequest: aRequest 
	message := aRequest.
	self printRequest.
	message := nil! !

!ALHttpPrinter methodsFor: 'printing' stamp: 'cwp 10/8/2012 14:08'!
printRequestLine

	out
		write: message method;
		put: Space.
	self printUrl: message url.
	out put: Space.
	self printVersion.
	out
		cr;
		lf! !

!ALHttpPrinter methodsFor: 'printing' stamp: 'cwp 9/6/2011 16:26'!
printResponse
	self printStatusLine.
	self printHeaders.
	out flush! !

!ALHttpPrinter methodsFor: 'dispatch' stamp: 'cwp 9/4/2011 01:30'!
printResponse: aResponse
	message := aResponse.
	self printResponse.
	message := nil! !

!ALHttpPrinter methodsFor: 'dispatch' stamp: 'cwp 7/12/2012 15:51'!
printSemicolonSequence: aCollection
	aCollection
		do: [:ea | ea printWith: self]
		separatedBy: [out write: '; ']! !

!ALHttpPrinter methodsFor: 'printing' stamp: 'cwp 10/25/2011 14:52'!
printStatusLine
	self printVersion.
	out space.
	ascii print: message status.
	out
		space;
		write: message reason;
		cr;
		lf! !

!ALHttpPrinter methodsFor: 'dispatch' stamp: 'cwp 7/13/2012 18:35'!
printString: aString
	out write: aString! !

!ALHttpPrinter methodsFor: 'printing' stamp: 'cwp 10/8/2012 14:14'!
printUrl: aUrl
	aUrl streamingPrintOn: ascii! !

!ALHttpPrinter methodsFor: 'printing' stamp: 'cwp 9/4/2011 01:35'!
printVersion
	out
		write: 'HTTP/';
		write: (String streamContents: [ :s | message version printFractionAsDecimalOn: s ])! !

Object subclass: #ALMimeMessage
	instanceVariableNames: 'headers body'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Core'!

ALMimeMessage subclass: #ALHttpEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Core'!

!ALHttpEntity class methodsFor: 'instance creation' stamp: 'cwp 9/5/2011 16:18'!
body: anObject
	^ self basicNew initializeWithBody: anObject! !

!ALHttpEntity class methodsFor: 'writing' stamp: 'cwp 9/8/2011 14:46'!
callback: aBlock
	^ self body: aBlock! !

!ALHttpEntity class methodsFor: 'writing' stamp: 'cwp 12/30/2012 11:37'!
empty
	^ (ALHttpEntity body: nil)
		contentLength: 0;
		yourself! !

!ALHttpEntity class methodsFor: 'writing' stamp: 'cwp 11/5/2012 00:25'!
html: aString
	^ (self callback: [:out | out write: aString])
		contentType: ALContentType html;
		contentLength: aString size;
		yourself! !

!ALHttpEntity class methodsFor: 'writing' stamp: 'cwp 1/11/2013 23:13'!
none
	^ (self body: nil)
		yourself! !

!ALHttpEntity class methodsFor: 'reading' stamp: 'cwp 9/8/2011 14:47'!
reading: aReadable
	^ self body: [aReadable reading]! !

!ALHttpEntity methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
allow
	^ self parseHeader: 'Allow' as: String! !

!ALHttpEntity methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
allow: aString
	headers at: 'Allow' put: aString
! !

!ALHttpEntity methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
contentEncoding
	^ self parseHeader: 'Content-Encoding' as: String! !

!ALHttpEntity methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
contentEncoding: aString
	headers at: 'Content-Encoding' put: aString
! !

!ALHttpEntity methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
contentLanguage
	^ self parseHeader: 'Content-Language' as: String! !

!ALHttpEntity methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
contentLanguage: aString
	headers at: 'Content-Language' put: aString
! !

!ALHttpEntity methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
contentLength
	^ self parseHeader: 'Content-Length' as: Integer! !

!ALHttpEntity methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
contentLength: anInteger
	headers at: 'Content-Length' put: anInteger
! !

!ALHttpEntity methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
contentLocation
	^ self parseHeader: 'Content-Location' as: String! !

!ALHttpEntity methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
contentLocation: aString
	headers at: 'Content-Location' put: aString
! !

!ALHttpEntity methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
contentMD5
	^ self parseHeader: 'Content-MD5' as: String! !

!ALHttpEntity methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
contentMD5: aString
	headers at: 'Content-MD5' put: aString
! !

!ALHttpEntity methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
contentRange
	^ self parseHeader: 'Content-Range' as: Interval! !

!ALHttpEntity methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
contentRange: anInterval
	headers at: 'Content-Range' put: anInterval
! !

!ALHttpEntity methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
contentType
	^ self parseHeader: 'Content-Type' as: ALContentType! !

!ALHttpEntity methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
contentType: anALContentType
	headers at: 'Content-Type' put: anALContentType
! !

!ALHttpEntity methodsFor: 'reading' stamp: 'cwp 11/4/2012 21:08'!
decodingReadFrom: aReadStream with: aBlock
	| in |
	in := aReadStream.
	self contentType ifNotNil:
		[:type |
		type hasCharset ifTrue:
			[in := in encoding: type charset]].
	^ self severingReadFrom: in with: aBlock! !

!ALHttpEntity methodsFor: 'writing' stamp: 'cwp 11/4/2012 21:35'!
encodingWriteInto: aWriteStream
	| out |
	out := aWriteStream.
	self contentType ifNotNil:
		[:type |
		type hasCharset ifTrue:
			[out := out encoding: type charset]].
	^ self severingWriteInto: out! !

!ALHttpEntity methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
expires
	^ self parseHeader: 'Expires' as: DateAndTime! !

!ALHttpEntity methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
expires: aDateAndTime
	headers at: 'Expires' put: aDateAndTime
! !

!ALHttpEntity methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasAllow
	^ headers includesKey: 'Allow'
! !

!ALHttpEntity methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasContentEncoding
	^ headers includesKey: 'Content-Encoding'
! !

!ALHttpEntity methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasContentLanguage
	^ headers includesKey: 'Content-Language'
! !

!ALHttpEntity methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasContentLength
	^ headers includesKey: 'Content-Length'
! !

!ALHttpEntity methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasContentLocation
	^ headers includesKey: 'Content-Location'
! !

!ALHttpEntity methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasContentMD5
	^ headers includesKey: 'Content-MD5'
! !

!ALHttpEntity methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasContentRange
	^ headers includesKey: 'Content-Range'
! !

!ALHttpEntity methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasContentType
	^ headers includesKey: 'Content-Type'
! !

!ALHttpEntity methodsFor: 'testing' stamp: 'cwp 12/6/2012 16:53'!
hasEntity	
	^ body notNil! !

!ALHttpEntity methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasExpires
	^ headers includesKey: 'Expires'
! !

!ALHttpEntity methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasLastModified
	^ headers includesKey: 'Last-Modified'
! !

!ALHttpEntity methodsFor: 'testing' stamp: 'cwp 10/25/2011 15:08'!
isEmpty
	^ headers isEmpty! !

!ALHttpEntity methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
lastModified
	^ self parseHeader: 'Last-Modified' as: DateAndTime! !

!ALHttpEntity methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
lastModified: aDateAndTime
	headers at: 'Last-Modified' put: aDateAndTime
! !

!ALHttpEntity methodsFor: 'reading' stamp: 'cwp 11/4/2012 21:07'!
limitingReadFrom: aReadStream with: aBlock
	| stream |
	stream := aReadStream.
	self contentLength ifNotNil: [:length | stream := stream limiting: length].
	^ self decodingReadFrom: stream with: aBlock! !

!ALHttpEntity methodsFor: 'writing' stamp: 'cwp 11/4/2012 21:37'!
limitingWriteInto: aWriteStream
	| out |
	out := aWriteStream.
	self contentLength ifNotNil: [ :length | out := out limiting: length ].
	^ self encodingWriteInto: out! !

!ALHttpEntity methodsFor: 'reading' stamp: 'cwp 11/4/2012 20:09'!
readWith: aBlock
	| aReadStream |
	body ifNil: [ ^ nil ].
	aReadStream := body value.
	^ self limitingReadFrom: aReadStream with: aBlock! !

!ALHttpEntity methodsFor: 'reading' stamp: 'cwp 11/4/2012 21:08'!
severingReadFrom: aReadStream with: aBlock
	| in |
	in := aReadStream severing.
	^ [aBlock value: in]
		ensure: [in close]! !

!ALHttpEntity methodsFor: 'writing' stamp: 'cwp 11/27/2012 20:05'!
severingWriteInto: aWriteStream
	| out |
	out := aWriteStream severing.
	^ [ self writeBodyInto: out ]
		ensure: [ out close ]! !

!ALHttpEntity methodsFor: 'writing' stamp: 'cwp 11/27/2012 20:05'!
writeBodyInto: out
	^ body value: out! !

!ALHttpEntity methodsFor: 'writing' stamp: 'cwp 11/4/2012 21:28'!
writeInto: aWriteStream
	body ifNil: [ ^ nil ].
	^ self limitingWriteInto: aWriteStream! !

ALMimeMessage subclass: #ALHttpMessage
	instanceVariableNames: 'version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Core'!

!ALHttpMessage class methodsFor: 'constants' stamp: 'cwp 9/5/2011 14:20'!
defaultVersion
	^ 1.1s1! !

!ALHttpMessage class methodsFor: 'instance creation' stamp: 'cwp 10/19/2011 19:41'!
readFrom: aReadStream
	| parser message |
	parser := ALHttpParser on: aReadStream.
	message := parser parse: self.
	message readEntityFrom: aReadStream.
	^ message! !

!ALHttpMessage methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
allow
	^ body allow
! !

!ALHttpMessage methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
allow: anObject
	^ body allow: anObject 
! !

!ALHttpMessage methodsFor: 'io' stamp: 'cwp 11/27/2012 20:06'!
basicWriteBodyInto: aWriteStream
	^ body writeBodyInto: aWriteStream! !

!ALHttpMessage methodsFor: 'headers - enum' stamp: 'cwp 12/13/2012 13:03'!
beConnectionClose
	self connection:  #[99 108 111 115 101]
! !

!ALHttpMessage methodsFor: 'headers - enum' stamp: 'cwp 12/13/2012 13:46'!
beConnectionKeepAlive
	self connection: #[107 101 101 112 45 97 108 105 118 101] ! !

!ALHttpMessage methodsFor: 'headers - enum' stamp: 'cwp 12/13/2012 12:58'!
beTransferEncodingChunked
	self transferEncoding: #[99 104 117 110 107 101 100]! !

!ALHttpMessage methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
cacheControl
	^ self parseHeader: 'Cache-Control' as: String! !

!ALHttpMessage methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
cacheControl: aString
	headers at: 'Cache-Control' put: aString
! !

!ALHttpMessage methodsFor: 'io' stamp: 'cwp 11/4/2012 20:06'!
chunkingReadFrom: aReadStream with: aBlock
	| in |
	in := self isTransferEncodingChunked
		ifTrue: [aReadStream chunking: 1024]
		ifFalse: [aReadStream].
	^ self limitingReadFrom: in with: aBlock! !

!ALHttpMessage methodsFor: 'io' stamp: 'cwp 11/27/2012 20:02'!
chunkingWriteInto: aStream
	| out |
	out := aStream.
	self isTransferEncodingChunked
		ifTrue: [ out := out chunking: 1024 ].
	^ self writeBodyInto: out! !

!ALHttpMessage methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
connection
	^ self parseHeader: 'Connection' as: String! !

!ALHttpMessage methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
connection: aString
	headers at: 'Connection' put: aString
! !

!ALHttpMessage methodsFor: 'entity' stamp: 'cwp 10/14/2011 23:59'!
consume
	self readEntityWith: [:in | in rest].  ! !

!ALHttpMessage methodsFor: 'entity' stamp: 'cwp 9/6/2011 15:50'!
content
	^ self readEntityWith: [:in | in rest]! !

!ALHttpMessage methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
contentEncoding
	^ body contentEncoding
! !

!ALHttpMessage methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
contentEncoding: anObject
	^ body contentEncoding: anObject 
! !

!ALHttpMessage methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
contentLanguage
	^ body contentLanguage
! !

!ALHttpMessage methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
contentLanguage: anObject
	^ body contentLanguage: anObject 
! !

!ALHttpMessage methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
contentLength
	^ body contentLength
! !

!ALHttpMessage methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
contentLength: anObject
	^ body contentLength: anObject 
! !

!ALHttpMessage methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
contentLocation
	^ body contentLocation
! !

!ALHttpMessage methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
contentLocation: anObject
	^ body contentLocation: anObject 
! !

!ALHttpMessage methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
contentMD5
	^ body contentMD5
! !

!ALHttpMessage methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
contentMD5: anObject
	^ body contentMD5: anObject 
! !

!ALHttpMessage methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
contentRange
	^ body contentRange
! !

!ALHttpMessage methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
contentRange: anObject
	^ body contentRange: anObject 
! !

!ALHttpMessage methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
contentType
	^ body contentType
! !

!ALHttpMessage methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
contentType: anObject
	^ body contentType: anObject 
! !

!ALHttpMessage methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
date
	^ self parseHeader: 'Date' as: DateAndTime! !

!ALHttpMessage methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
date: aDateAndTime
	headers at: 'Date' put: aDateAndTime
! !

!ALHttpMessage methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
expires
	^ body expires
! !

!ALHttpMessage methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
expires: anObject
	^ body expires: anObject 
! !

!ALHttpMessage methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasAllow
	^ body hasAllow
! !

!ALHttpMessage methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasCacheControl
	^ headers includesKey: 'Cache-Control'
! !

!ALHttpMessage methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasConnection
	^ headers includesKey: 'Connection'
! !

!ALHttpMessage methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasContentEncoding
	^ body hasContentEncoding
! !

!ALHttpMessage methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasContentLanguage
	^ body hasContentLanguage
! !

!ALHttpMessage methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasContentLength
	^ body hasContentLength
! !

!ALHttpMessage methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasContentLocation
	^ body hasContentLocation
! !

!ALHttpMessage methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasContentMD5
	^ body hasContentMD5
! !

!ALHttpMessage methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasContentRange
	^ body hasContentRange
! !

!ALHttpMessage methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasContentType
	^ body hasContentType
! !

!ALHttpMessage methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasDate
	^ headers includesKey: 'Date'
! !

!ALHttpMessage methodsFor: 'entity' stamp: 'cwp 12/6/2012 16:53'!
hasEntity
	^ body hasEntity! !

!ALHttpMessage methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasExpires
	^ body hasExpires
! !

!ALHttpMessage methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasLastModified
	^ body hasLastModified
! !

!ALHttpMessage methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasPragma
	^ headers includesKey: 'Pragma'
! !

!ALHttpMessage methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasTrailer
	^ headers includesKey: 'Trailer'
! !

!ALHttpMessage methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasTransferEncoding
	^ headers includesKey: 'Transfer-Encoding'
! !

!ALHttpMessage methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasUpgrade
	^ headers includesKey: 'Upgrade'
! !

!ALHttpMessage methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasVia
	^ headers includesKey: 'Via'
! !

!ALHttpMessage methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasWarning
	^ headers includesKey: 'Warning'
! !

!ALHttpMessage methodsFor: 'accessing' stamp: 'cwp 12/13/2012 13:06'!
headerAt: aString ifAbsent: aBlock
	^ (self class entityHeaders includes: aString)
		ifTrue: [body headerAt: aString ifAbsent: aBlock]
		ifFalse: [headers at: aString ifAbsent: aBlock]
! !

!ALHttpMessage methodsFor: 'accessing' stamp: 'cwp 12/13/2012 13:07'!
headerAt: aString put: aByteArray
	(self class entityHeaders includes: aString)
		ifTrue: [body headerAt: aString put: aByteArray]
		ifFalse: [headers at: aString put: aByteArray]
! !

!ALHttpMessage methodsFor: 'accessing' stamp: 'cwp 12/13/2012 13:07'!
headersDo: aBlock
	super headersDo: aBlock.
	body headersDo: aBlock.! !

!ALHttpMessage methodsFor: 'initialize-release' stamp: 'cwp 9/5/2011 14:11'!
initializeWithVersion: aScaledDecimal body: anEntity
	self initializeWithBody: anEntity.
	version := aScaledDecimal ! !

!ALHttpMessage methodsFor: 'headers - enum' stamp: 'cwp 12/13/2012 13:47'!
isConnectionClose
	^ self hasConnection
		ifTrue: [self connection = 'close']
		ifFalse: [false]
	
	! !

!ALHttpMessage methodsFor: 'headers - enum' stamp: 'cwp 12/13/2012 13:48'!
isConnectionKeepAlive
	^ self hasConnection
		ifTrue: [self connection ~= 'close']
		ifFalse: [true]! !

!ALHttpMessage methodsFor: 'headers - enum' stamp: 'cwp 12/13/2012 12:56'!
isTransferEncodingChunked
	^ self transferEncoding = 'chunked'! !

!ALHttpMessage methodsFor: 'io' stamp: 'cwp 11/5/2012 00:16'!
keepAliveWriteInto: aWriteStream
	| out |
	out := aWriteStream.
	self isConnectionKeepAlive ifTrue:
		[out := out closing: []].
	self chunkingWriteInto: out! !

!ALHttpMessage methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
lastModified
	^ body lastModified
! !

!ALHttpMessage methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
lastModified: anObject
	^ body lastModified: anObject 
! !

!ALHttpMessage methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
pragma
	^ self parseHeader: 'Pragma' as: String! !

!ALHttpMessage methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
pragma: aString
	headers at: 'Pragma' put: aString
! !

!ALHttpMessage methodsFor: 'entity' stamp: 'cwp 10/25/2011 15:08'!
readEntityFrom: aReadStream
	body isEmpty ifFalse: [body body: [aReadStream]]! !

!ALHttpMessage methodsFor: 'entity' stamp: 'cwp 9/6/2011 15:51'!
readEntityWith: aBlock
	^ body readWith: aBlock! !

!ALHttpMessage methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
trailer
	^ self parseHeader: 'Trailer' as: String! !

!ALHttpMessage methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
trailer: aString
	headers at: 'Trailer' put: aString
! !

!ALHttpMessage methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
transferEncoding
	^ self parseHeader: 'Transfer-Encoding' as: String! !

!ALHttpMessage methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
transferEncoding: aString
	headers at: 'Transfer-Encoding' put: aString
! !

!ALHttpMessage methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
upgrade
	^ self parseHeader: 'Upgrade' as: String! !

!ALHttpMessage methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
upgrade: aString
	headers at: 'Upgrade' put: aString
! !

!ALHttpMessage methodsFor: 'accessing' stamp: 'cwp 4/24/2011 21:16'!
version
	^ version! !

!ALHttpMessage methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
via
	^ self parseHeader: 'Via' as: String! !

!ALHttpMessage methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
via: aString
	headers at: 'Via' put: aString
! !

!ALHttpMessage methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
warning
	^ self parseHeader: 'Warning' as: String! !

!ALHttpMessage methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
warning: aString
	headers at: 'Warning' put: aString
! !

!ALHttpMessage methodsFor: 'io' stamp: 'cwp 11/27/2012 20:02'!
writeBodyInto: out
	^ body writeInto: out! !

!ALHttpMessage methodsFor: 'entity' stamp: 'cwp 9/8/2011 23:48'!
writeEntityWith: aBlock
	body body: aBlock! !

!ALHttpMessage methodsFor: 'io' stamp: 'cwp 11/5/2012 00:15'!
writeInto: aStream
	ALHttpPrinter print: self on: aStream.
	self keepAliveWriteInto: aStream! !

ALHttpMessage subclass: #ALRequest
	instanceVariableNames: 'method url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Core'!

!ALRequest class methodsFor: 'convenience' stamp: 'cwp 12/13/2012 12:57'!
get: aUrl 
	^ (self method: 'GET' url: aUrl)
		userAgent: self userAgent;
		accept: ALContentType anything;
		yourself! !

!ALRequest class methodsFor: 'instance creation' stamp: 'cwp 1/1/2013 14:08'!
method: aString url: aUrl
	^ self
		method: aString
		url: aUrl
		version: self defaultVersion
		body: ALHttpEntity none! !

!ALRequest class methodsFor: 'instance creation' stamp: 'cwp 12/30/2012 11:37'!
method: aString url: aUrl version: aScaledDecimal 
	^ self 
		method: aString 
		url: aUrl 
		version: aScaledDecimal 
		body: ALHttpEntity empty! !

!ALRequest class methodsFor: 'instance creation' stamp: 'cwp 10/8/2012 00:04'!
method: aString url: aUrl version: aScaledDecimal body: anEntity
	^ self basicNew
		initializeWithMethod: aString 
		url: aUrl 
		version: aScaledDecimal 
		body: anEntity ! !

!ALRequest class methodsFor: 'dispatch' stamp: 'cwp 10/19/2011 19:42'!
parseWith: aParser
	^ aParser parseRequest! !

!ALRequest class methodsFor: 'accessing' stamp: 'cwp 9/4/2011 02:01'!
userAgent
	^ 'Altitude/0.1'! !

!ALRequest methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
accept
	^ self parseHeader: 'Accept' as: ALContentTypes! !

!ALRequest methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
accept: anALContentTypes
	headers at: 'Accept' put: anALContentTypes
! !

!ALRequest methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
acceptCharset
	^ self parseHeader: 'Accept-Charset' as: String! !

!ALRequest methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
acceptCharset: aString
	headers at: 'Accept-Charset' put: aString
! !

!ALRequest methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
acceptEncoding
	^ self parseHeader: 'Accept-Encoding' as: String! !

!ALRequest methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
acceptEncoding: aString
	headers at: 'Accept-Encoding' put: aString
! !

!ALRequest methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
acceptLanguage
	^ self parseHeader: 'Accept-Language' as: String! !

!ALRequest methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
acceptLanguage: aString
	headers at: 'Accept-Language' put: aString
! !

!ALRequest methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
authorization
	^ self parseHeader: 'Authorization' as: String! !

!ALRequest methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
authorization: aString
	headers at: 'Authorization' put: aString
! !

!ALRequest methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
cookie
	^ self parseHeader: 'Cookie' as: ALCookieValues! !

!ALRequest methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
cookie: anALCookieValues
	headers at: 'Cookie' put: anALCookieValues
! !

!ALRequest methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
expect
	^ self parseHeader: 'Expect' as: String! !

!ALRequest methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
expect: aString
	headers at: 'Expect' put: aString
! !

!ALRequest methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
from
	^ self parseHeader: 'From' as: String! !

!ALRequest methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
from: aString
	headers at: 'From' put: aString
! !

!ALRequest methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasAccept
	^ headers includesKey: 'Accept'
! !

!ALRequest methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasAcceptCharset
	^ headers includesKey: 'Accept-Charset'
! !

!ALRequest methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasAcceptEncoding
	^ headers includesKey: 'Accept-Encoding'
! !

!ALRequest methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasAcceptLanguage
	^ headers includesKey: 'Accept-Language'
! !

!ALRequest methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasAuthorization
	^ headers includesKey: 'Authorization'
! !

!ALRequest methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasCookie
	^ headers includesKey: 'Cookie'
! !

!ALRequest methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasExpect
	^ headers includesKey: 'Expect'
! !

!ALRequest methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasFrom
	^ headers includesKey: 'From'
! !

!ALRequest methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasHost
	^ headers includesKey: 'Host'
! !

!ALRequest methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasIfMatch
	^ headers includesKey: 'If-Match'
! !

!ALRequest methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasIfModifiedSince
	^ headers includesKey: 'If-Modified-Since'
! !

!ALRequest methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasIfNoneMatch
	^ headers includesKey: 'If-None-Match'
! !

!ALRequest methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasIfRange
	^ headers includesKey: 'If-Range'
! !

!ALRequest methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasIfUnmodifiedSince
	^ headers includesKey: 'If-Unmodified-Since'
! !

!ALRequest methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasMaxForwards
	^ headers includesKey: 'Max-Forwards'
! !

!ALRequest methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasProxyAuthorization
	^ headers includesKey: 'Proxy-Authorization'
! !

!ALRequest methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasRange
	^ headers includesKey: 'Range'
! !

!ALRequest methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasReferer
	^ headers includesKey: 'Referer'
! !

!ALRequest methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasTe
	^ headers includesKey: 'TE'
! !

!ALRequest methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasUserAgent
	^ headers includesKey: 'User-Agent'
! !

!ALRequest methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
host
	^ self parseHeader: 'Host' as: ALHost! !

!ALRequest methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
host: anALHost
	headers at: 'Host' put: anALHost
! !

!ALRequest methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
ifMatch
	^ self parseHeader: 'If-Match' as: ALEtag! !

!ALRequest methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
ifMatch: anALEtag
	headers at: 'If-Match' put: anALEtag
! !

!ALRequest methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
ifModifiedSince
	^ self parseHeader: 'If-Modified-Since' as: DateAndTime! !

!ALRequest methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
ifModifiedSince: aDateAndTime
	headers at: 'If-Modified-Since' put: aDateAndTime
! !

!ALRequest methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
ifNoneMatch
	^ self parseHeader: 'If-None-Match' as: ALEtag! !

!ALRequest methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
ifNoneMatch: anALEtag
	headers at: 'If-None-Match' put: anALEtag
! !

!ALRequest methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
ifRange
	^ self parseHeader: 'If-Range' as: Interval! !

!ALRequest methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
ifRange: anInterval
	headers at: 'If-Range' put: anInterval
! !

!ALRequest methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
ifUnmodifiedSince
	^ self parseHeader: 'If-Unmodified-Since' as: DateAndTime! !

!ALRequest methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
ifUnmodifiedSince: aDateAndTime
	headers at: 'If-Unmodified-Since' put: aDateAndTime
! !

!ALRequest methodsFor: 'initialize-release' stamp: 'cwp 10/8/2012 00:04'!
initializeWithMethod: aString url: aUrl version: aScaledDecimal body: anEntity
	self initializeWithVersion: aScaledDecimal body: anEntity.
	method := aString.
	url := aUrl.
	! !

!ALRequest methodsFor: 'methods - testing' stamp: 'cwp 12/25/2012 11:50'!
isMethodConnect
	^ method = 'CONNECT'
! !

!ALRequest methodsFor: 'methods - testing' stamp: 'cwp 12/25/2012 11:50'!
isMethodDelete
	^ method = 'DELETE'
! !

!ALRequest methodsFor: 'methods - testing' stamp: 'cwp 12/25/2012 11:50'!
isMethodGet
	^ method = 'GET'
! !

!ALRequest methodsFor: 'methods - testing' stamp: 'cwp 12/25/2012 11:50'!
isMethodHead
	^ method = 'HEAD'
! !

!ALRequest methodsFor: 'methods - testing' stamp: 'cwp 12/25/2012 11:50'!
isMethodOptions
	^ method = 'OPTIONS'
! !

!ALRequest methodsFor: 'methods - testing' stamp: 'cwp 12/25/2012 11:50'!
isMethodPost
	^ method = 'POST'
! !

!ALRequest methodsFor: 'methods - testing' stamp: 'cwp 12/25/2012 11:50'!
isMethodPut
	^ method = 'PUT'
! !

!ALRequest methodsFor: 'methods - testing' stamp: 'cwp 12/25/2012 11:50'!
isMethodTrace
	^ method = 'TRACE'
! !

!ALRequest methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
maxForwards
	^ self parseHeader: 'Max-Forwards' as: String! !

!ALRequest methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
maxForwards: aString
	headers at: 'Max-Forwards' put: aString
! !

!ALRequest methodsFor: 'accessing' stamp: 'cwp 4/24/2011 21:01'!
method
	^ method! !

!ALRequest methodsFor: 'accessing' stamp: 'cwp 10/7/2012 23:32'!
path
	^ url path! !

!ALRequest methodsFor: 'dispatch' stamp: 'cwp 10/19/2011 19:37'!
printWith: aPrinter
	aPrinter printRequest: self! !

!ALRequest methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
proxyAuthorization
	^ self parseHeader: 'Proxy-Authorization' as: String! !

!ALRequest methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
proxyAuthorization: aString
	headers at: 'Proxy-Authorization' put: aString
! !

!ALRequest methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
range
	^ self parseHeader: 'Range' as: String! !

!ALRequest methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
range: aString
	headers at: 'Range' put: aString
! !

!ALRequest methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
referer
	^ self parseHeader: 'Referer' as: ALUrl! !

!ALRequest methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
referer: anALUrl
	headers at: 'Referer' put: anALUrl
! !

!ALRequest methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
te
	^ self parseHeader: 'TE' as: String! !

!ALRequest methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
te: aString
	headers at: 'TE' put: aString
! !

!ALRequest methodsFor: 'accessing' stamp: 'cwp 10/8/2012 00:03'!
url
	^ url! !

!ALRequest methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
userAgent
	^ self parseHeader: 'User-Agent' as: String! !

!ALRequest methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
userAgent: aString
	headers at: 'User-Agent' put: aString
! !

ALHttpMessage subclass: #ALResponse
	instanceVariableNames: 'status reason'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Core'!

!ALResponse class methodsFor: 'common responses' stamp: 'cwp 12/25/2012 11:43'!
created
	^ self status: 201 reason: 'Created' ! !

!ALResponse class methodsFor: 'common responses' stamp: 'cwp 7/13/2012 20:05'!
forbidden
	^ self status: 403 reason: 'Forbidden' details: 'You have not logged in'! !

!ALResponse class methodsFor: 'common responses' stamp: 'cwp 9/30/2011 22:59'!
notFound: aPath
	^ self 
		status: 404 
		reason: 'Not Found'
		details: aPath asString, ' does not exist on this server'! !

!ALResponse class methodsFor: 'common responses' stamp: 'cwp 9/9/2011 00:06'!
ok
	^ self status: 200 reason: 'OK'! !

!ALResponse class methodsFor: 'dispatch' stamp: 'cwp 10/19/2011 19:42'!
parseWith: aParser
	^ aParser parseResponse! !

!ALResponse class methodsFor: 'common responses' stamp: 'cwp 12/22/2012 08:53'!
seeOther: aUrl
	^ (self status: 303 reason: 'See Other')
		location: aUrl
		yourself! !

!ALResponse class methodsFor: 'instance creation' stamp: 'cwp 1/14/2013 21:55'!
status: anInteger reason: aString
	^ self 	
		status: anInteger 
		reason: aString 
		version: self defaultVersion 
		body: ALHttpEntity none! !

!ALResponse class methodsFor: 'instance creation' stamp: 'cwp 9/5/2011 14:18'!
status: anInteger reason: aString body: anEntity
	^ self 
		status: anInteger 
		reason: aString 
		version: self defaultVersion  
		body: anEntity! !

!ALResponse class methodsFor: 'common responses' stamp: 'cwp 12/30/2012 11:37'!
status: status reason: aString details: aString2
	| html |
	html := String new writing
		write: '<!!DOCTYPE html><html><head><title>';
		print: status;
		space;
		write: aString;
		write: '</title></head><body><h1>';
		write: aString;
		write: '</h1><p>';
		write: aString2;
		write: '</p></body></html>';
		conclusion.
	^ self status: status reason: aString body: (ALHttpEntity html: html)! !

!ALResponse class methodsFor: 'instance creation' stamp: 'cwp 1/14/2013 21:48'!
status: anInteger reason: aString version: aScaledDecimal
	^ self 
		status: anInteger 
		reason: aString 
		version: aScaledDecimal 
		body: ALHttpEntity none! !

!ALResponse class methodsFor: 'instance creation' stamp: 'cwp 9/5/2011 14:14'!
status: anInteger reason: aString version: aScaledDecimal body: anEntity
	^ self basicNew
		initializeWithStatus: anInteger 
		reason: aString
		version: aScaledDecimal
		body: anEntity! !

!ALResponse class methodsFor: 'common responses' stamp: 'cwp 12/30/2012 11:37'!
type: aContentType callback: aBlock
	| entity |
	entity := ALHttpEntity callback: aBlock.
	entity contentType: aContentType.
	^ (self status: 200 reason: 'OK' body: entity)
		beTransferEncodingChunked;
		yourself! !

!ALResponse methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
acceptRanges
	^ self parseHeader: 'Accept-Ranges' as: String! !

!ALResponse methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
acceptRanges: aString
	headers at: 'Accept-Ranges' put: aString
! !

!ALResponse methodsFor: 'headers - convenience' stamp: 'cwp 12/25/2012 12:25'!
addCookie: aCookie
	| specs |
	specs := headers at: 'Set-Cookie' ifAbsent: [ALCookieSpecs new].
	headers at: 'Set-Cookie' put: (specs copyWith: aCookie)! !

!ALResponse methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
age
	^ self parseHeader: 'Age' as: String! !

!ALResponse methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
age: aString
	headers at: 'Age' put: aString
! !

!ALResponse methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
etag
	^ self parseHeader: 'ETag' as: ALEtag! !

!ALResponse methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
etag: anALEtag
	headers at: 'ETag' put: anALEtag
! !

!ALResponse methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasAcceptRanges
	^ headers includesKey: 'Accept-Ranges'
! !

!ALResponse methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasAge
	^ headers includesKey: 'Age'
! !

!ALResponse methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasEtag
	^ headers includesKey: 'ETag'
! !

!ALResponse methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasLocation
	^ headers includesKey: 'Location'
! !

!ALResponse methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasProxyAuthenticate
	^ headers includesKey: 'Proxy-Authenticate'
! !

!ALResponse methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasRetryAfter
	^ headers includesKey: 'Retry-After'
! !

!ALResponse methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasServer
	^ headers includesKey: 'Server'
! !

!ALResponse methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasSetCookie
	^ headers includesKey: 'Set-Cookie'
! !

!ALResponse methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasVary
	^ headers includesKey: 'Vary'
! !

!ALResponse methodsFor: 'headers - testing' stamp: 'cwp 12/25/2012 11:50'!
hasWwwAuthenticate
	^ headers includesKey: 'WWW-Authenticate'
! !

!ALResponse methodsFor: 'initialize-release' stamp: 'cwp 9/5/2011 14:29'!
initializeWithStatus: anInteger reason: aString version: aScaledDecimal body: anEntity
	self initializeWithVersion: aScaledDecimal body: anEntity.
	status := anInteger.
	reason := aString.
	! !

!ALResponse methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
location
	^ self parseHeader: 'Location' as: ALUrl! !

!ALResponse methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
location: anALUrl
	headers at: 'Location' put: anALUrl
! !

!ALResponse methodsFor: 'dispatch' stamp: 'cwp 10/19/2011 19:37'!
printWith: aPrinter
	aPrinter printResponse: self! !

!ALResponse methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
proxyAuthenticate
	^ self parseHeader: 'Proxy-Authenticate' as: String! !

!ALResponse methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
proxyAuthenticate: aString
	headers at: 'Proxy-Authenticate' put: aString
! !

!ALResponse methodsFor: 'accessing' stamp: 'cwp 4/23/2011 16:23'!
reason
	^ reason! !

!ALResponse methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
retryAfter
	^ self parseHeader: 'Retry-After' as: String! !

!ALResponse methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
retryAfter: aString
	headers at: 'Retry-After' put: aString
! !

!ALResponse methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
server
	^ self parseHeader: 'Server' as: String! !

!ALResponse methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
server: aString
	headers at: 'Server' put: aString
! !

!ALResponse methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
setCookie
	^ self parseHeader: 'Set-Cookie' as: ALCookieSpecs! !

!ALResponse methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
setCookie: anALCookieSpecs
	headers at: 'Set-Cookie' put: anALCookieSpecs
! !

!ALResponse methodsFor: 'accessing' stamp: 'cwp 4/23/2011 16:23'!
status
	^ status! !

!ALResponse methodsFor: 'accessing' stamp: 'cwp 1/14/2013 21:38'!
stream: aBlock
	body body: aBlock.
	self beTransferEncodingChunked.! !

!ALResponse methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
vary
	^ self parseHeader: 'Vary' as: ALStrings! !

!ALResponse methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
vary: anALStrings
	headers at: 'Vary' put: anALStrings
! !

!ALResponse methodsFor: 'headers - getting' stamp: 'cwp 12/25/2012 11:50'!
wwwAuthenticate
	^ self parseHeader: 'WWW-Authenticate' as: String! !

!ALResponse methodsFor: 'headers - setting' stamp: 'cwp 12/25/2012 11:50'!
wwwAuthenticate: aString
	headers at: 'WWW-Authenticate' put: aString
! !

!ALMimeMessage class methodsFor: 'as yet unclassified' stamp: 'cwp 9/5/2011 14:45'!
entityHeaders
	^ #(
		'Content-Encoding' 
		'Content-Language'
		'Content-Length'
		'Content-Location'
		'Content-MD5'
		'Content-Range'
		'Content-Type'
		'Expires'
		'Last-Modified'
	)! !

!ALMimeMessage methodsFor: 'accessing' stamp: 'cwp 9/7/2011 14:47'!
body
	^ body! !

!ALMimeMessage methodsFor: 'accessing' stamp: 'cwp 5/2/2011 18:33'!
body: anObject
	 body := anObject! !

!ALMimeMessage methodsFor: 'accessing' stamp: 'cwp 12/13/2012 12:55'!
headerAt: name ifAbsent: aBlock 
	^ headers at: name ifAbsent: aBlock! !

!ALMimeMessage methodsFor: 'accessing' stamp: 'cwp 12/13/2012 12:54'!
headerAt: name put: value 
	^ headers at: name put: value! !

!ALMimeMessage methodsFor: 'accessing' stamp: 'cwp 12/13/2012 12:52'!
headersDo: aBlock
	headers keysAndValuesDo: aBlock! !

!ALMimeMessage methodsFor: 'initialize-release' stamp: 'cwp 11/5/2012 00:39'!
initializeWithBody: anObject
	self initialize.
	headers := Dictionary new.
	body := anObject.
! !

!ALMimeMessage methodsFor: 'parsing' stamp: 'cwp 10/25/2011 13:36'!
parseHeader: aString as: aClass
	^ self parseHeader: aString with: [:value | ALHttpParser parse: value as: aClass]! !

!ALMimeMessage methodsFor: 'parsing' stamp: 'cwp 7/11/2012 21:32'!
parseHeader: aString with: aBlock
	^ headers
		at: aString
		ifPresent:
			[:value |
			value class == ByteArray
				ifTrue: [headers at: aString put: (aBlock value: value)]
				ifFalse: [value]]! !

Object subclass: #ALParameterizedValue
	instanceVariableNames: 'parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Values'!

ALParameterizedValue subclass: #ALContentType
	instanceVariableNames: 'type subtype'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Values'!

!ALContentType class methodsFor: 'common types' stamp: 'cwp 12/13/2012 12:58'!
anything
	^ self type: '*' subtype: '*'! !

!ALContentType class methodsFor: 'common types' stamp: 'cwp 10/25/2011 12:59'!
ascii
	^ self type: 'text' subtype: 'plain' charset: 'ascii'
	! !

!ALContentType class methodsFor: 'common types' stamp: 'cwp 10/25/2011 12:59'!
css
	^ self type: 'text' subtype: 'css' charset: 'UTF-8'! !

!ALContentType class methodsFor: 'common types' stamp: 'cwp 10/25/2011 13:02'!
favicon
	^ self type: 'image' subtype: 'vnd.microsoft.icon'! !

!ALContentType class methodsFor: 'common types' stamp: 'cwp 10/25/2011 13:00'!
html
	^ self type: 'text' subtype: 'html' charset: 'UTF-8'
	
		! !

!ALContentType class methodsFor: 'common types' stamp: 'cwp 10/25/2011 13:03'!
javascript
	^ self type: 'application' subtype: 'javascript' charset: 'UTF-8'! !

!ALContentType class methodsFor: 'common types' stamp: 'cwp 10/25/2011 13:00'!
json
	^ self type: 'application' subtype: 'json' charset: 'UTF-8'! !

!ALContentType class methodsFor: 'common types' stamp: 'cwp 10/25/2011 13:03'!
less
	^ self type: 'text' subtype: 'x-lesscss' charset: 'UTF-8'! !

!ALContentType class methodsFor: 'common types' stamp: 'cwp 11/4/2012 22:18'!
octets
	^ self type: 'application' subtype: 'octet-stream'! !

!ALContentType class methodsFor: 'dispatch' stamp: 'cwp 10/24/2011 14:14'!
parseWith: aParser
	^ aParser parseContentType! !

!ALContentType class methodsFor: 'common types' stamp: 'cwp 10/25/2011 13:04'!
png
	^ self type: 'image' subtype: 'png' ! !

!ALContentType class methodsFor: 'instance creation' stamp: 'cwp 9/7/2011 15:56'!
type: typeString subtype: subtypeString
	^ self basicNew
		initializeWithType: typeString subtype: subtypeString! !

!ALContentType class methodsFor: 'instance creation' stamp: 'cwp 10/25/2011 12:58'!
type: type subtype: subtype charset: charset
	^ (self type: type subtype: subtype)
		charset: charset
		! !

!ALContentType methodsFor: 'comparing' stamp: 'cwp 10/22/2011 12:28'!
= other
	self species = other species ifFalse: [^ false].
	self type = other type ifFalse: [^ false].
	self subtype = other subtype ifFalse: [^ false].
	self parametersDo:
		[:name :value || expected |
		expected := other parameter: name ifAbsent: [^ false].
		value = expected ifFalse: [^ false]].
	^ true! !

!ALContentType methodsFor: 'converting' stamp: 'cwp 7/11/2012 22:44'!
asByteArray
	| ws |
	ws := ByteArray new writing.
	ws
		write: type;
		put: $/ asciiValue;
		write: subtype.
	self writeParametersOn: ws.
	^ ws conclusion! !

!ALContentType methodsFor: 'parameters' stamp: 'cwp 9/8/2011 14:15'!
charset
	^ (self parameter: 'charset' ifAbsent: [^ nil]) asLowercase asSymbol! !

!ALContentType methodsFor: 'parameters' stamp: 'cwp 9/8/2011 14:29'!
charset: aString
	self parameter: 'charset' value: aString asSymbol! !

!ALContentType methodsFor: 'testing' stamp: 'cwp 9/8/2011 14:18'!
hasCharset
	^ parameters includesKey: 'charset' ! !

!ALContentType methodsFor: 'comparing' stamp: 'cwp 10/22/2011 12:32'!
hash
	| hash |
	hash := String stringHash: type initialHash: self class hash.
	hash := String stringHash: subtype initialHash: hash.
	self parametersDo:
		[:name :value |
		hash := String stringHash: name initialHash: hash.
		hash := String stringHash: value initialHash: hash].
	^ hash
	! !

!ALContentType methodsFor: 'initialize-release' stamp: 'cwp 9/7/2011 15:59'!
initializeWithType: typeString subtype: subtypeString
	self initialize.
	type := typeString asLowercase.
	subtype := subtypeString asLowercase.
	parameters := Dictionary new.! !

!ALContentType methodsFor: 'testing' stamp: 'cwp 9/7/2011 16:01'!
isHtml
	^ self isText and: [subtype = 'html']! !

!ALContentType methodsFor: 'testing' stamp: 'cwp 9/7/2011 16:09'!
isImage
	^ type = 'image'! !

!ALContentType methodsFor: 'testing' stamp: 'cwp 9/7/2011 16:10'!
isJpeg
	^ self isImage and: [subtype = 'jpeg']! !

!ALContentType methodsFor: 'testing' stamp: 'cwp 3/31/2012 22:39'!
isJson
	^ type = 'application' and: [subtype = 'json']! !

!ALContentType methodsFor: 'testing' stamp: 'cwp 9/7/2011 16:01'!
isText
	^ self type = 'text'! !

!ALContentType methodsFor: 'as yet unclassified' stamp: 'cwp 12/19/2012 22:49'!
printString
	^ String new writing
		print: self;
		conclusion! !

!ALContentType methodsFor: 'dispatch' stamp: 'cwp 10/25/2011 14:23'!
printWith: aPrinter
	aPrinter printContentType: self  ! !

!ALContentType methodsFor: 'as yet unclassified' stamp: 'cwp 12/19/2012 22:48'!
streamingPrintOn: aWriteStream
	aWriteStream
		write: type;
		put: $/;
		write: subtype! !

!ALContentType methodsFor: 'accessing' stamp: 'cwp 9/7/2011 16:00'!
subtype
	^ subtype ! !

!ALContentType methodsFor: 'accessing' stamp: 'cwp 9/7/2011 16:00'!
type
	^ type! !

ALParameterizedValue subclass: #ALCookie
	instanceVariableNames: 'name value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Values'!

!ALCookie class methodsFor: 'instance creation' stamp: 'cwp 7/11/2012 22:14'!
name: nameString value: valueString
	^ self name: nameString value: valueString parameters: Dictionary new! !

!ALCookie class methodsFor: 'instance creation' stamp: 'cwp 7/11/2012 22:17'!
name: nameString value: valueString parameters: aDictionary 
	^ self basicNew 
		initializeWithName: nameString
		value: valueString
		parameters: aDictionary! !

!ALCookie methodsFor: 'parameters' stamp: 'cwp 7/11/2012 22:50'!
domain
	^ (self parameter: 'domain' ifAbsent: [^ nil]) asLowercase! !

!ALCookie methodsFor: 'parameters' stamp: 'cwp 7/12/2012 15:22'!
domain: aString
	self parameter: 'domain' value: aString asLowercase! !

!ALCookie methodsFor: 'initialize-release' stamp: 'cwp 7/11/2012 22:17'!
initializeWithName: nameString value: valueString parameters: aDictionary 
	self initialize.
	name := nameString.
	value := valueString.
	parameters := aDictionary! !

!ALCookie methodsFor: 'parameters' stamp: 'cwp 1/25/2013 12:00'!
maxAge
	^ self parameter: 'max-age' 
		ifPresent: [:v | XTNumberParser parse: v]
		ifAbsent: [nil]! !

!ALCookie methodsFor: 'parameters' stamp: 'cwp 1/25/2013 11:58'!
maxAge: anInteger
	self parameter: 'max-age' value: anInteger printString! !

!ALCookie methodsFor: 'accessing' stamp: 'cwp 7/11/2012 22:47'!
name
	^ name! !

!ALCookie methodsFor: 'parameters' stamp: 'cwp 7/11/2012 22:52'!
path
	self parameter: 'path' ! !

!ALCookie methodsFor: 'parameters' stamp: 'cwp 7/12/2012 15:23'!
path: aPathOrString
	self parameter: 'path' value: aPathOrString asString ! !

!ALCookie methodsFor: 'printing' stamp: 'cwp 7/12/2012 15:43'!
printWith: aPrinter
	aPrinter printCookie: self! !

!ALCookie methodsFor: 'accessing' stamp: 'cwp 7/11/2012 22:47'!
value
	^ value! !

!ALParameterizedValue methodsFor: 'accessing' stamp: 'cwp 7/11/2012 22:40'!
parameter: aString
	^ self parameter: aString ifAbsent: [nil]! !

!ALParameterizedValue methodsFor: 'accessing' stamp: 'cwp 7/11/2012 22:41'!
parameter: aString ifAbsent: aBlock
	^ parameters at: aString ifAbsent: aBlock! !

!ALParameterizedValue methodsFor: 'accessing' stamp: 'cwp 1/25/2013 12:01'!
parameter: aString ifPresent: pBlock ifAbsent: aBlock
	^ parameters at: aString ifPresent: pBlock ifAbsent: aBlock! !

!ALParameterizedValue methodsFor: 'accessing' stamp: 'cwp 7/11/2012 22:40'!
parameter: pString value: vString
	parameters at: pString put: vString! !

!ALParameterizedValue methodsFor: 'accessing' stamp: 'cwp 7/11/2012 22:42'!
parameters
	^ parameters! !

!ALParameterizedValue methodsFor: 'accessing' stamp: 'cwp 7/11/2012 22:40'!
parametersDo: aBlock
	parameters keysAndValuesDo: aBlock! !

!ALParameterizedValue methodsFor: 'converting' stamp: 'cwp 7/11/2012 22:45'!
writeParametersOn: aBinaryWriteStream
	parameters keysAndValuesDo: 
		[ :attribute :value | 
		aBinaryWriteStream
			write: #[59 32];
			write: attribute;
			put: 61;
			write: value ]! !

Object subclass: #ALRelay
	instanceVariableNames: 'destination'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Relays'!

ALRelay subclass: #ALHttpExceptionRelay
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Relays'!

!ALHttpExceptionRelay methodsFor: 'dispatch' stamp: 'cwp 12/13/2012 22:39'!
handleMalformedRequest: anALMalformedRequest 
	^ ALResponse  
		status: 400 
		reason: 'Malformed Request'
		! !

!ALHttpExceptionRelay methodsFor: 'dispatch' stamp: 'cwp 11/30/2012 20:26'!
handleMethodNotAllowed: anException
	^ ALResponse
		status: 405
		reason: 'Method not allowed'
	! !

!ALHttpExceptionRelay methodsFor: 'dispatch' stamp: 'cwp 11/30/2012 20:26'!
handleNotAcceptable: anError
	^ ALResponse status: 406 reason: 'Not Acceptable'! !

!ALHttpExceptionRelay methodsFor: 'dispatch' stamp: 'cwp 11/30/2012 20:26'!
handleNotFound: anError
	^ ALResponse notFound: anError messageText! !

!ALHttpExceptionRelay methodsFor: 'public' stamp: 'cwp 11/30/2012 20:27'!
handleRequest: aRequest
	^ [destination handleRequest: aRequest ] 
		on: ALHttpError 
		do:	[:err | 
			aRequest consume.
			err handleWith: self]! !

!ALHttpExceptionRelay methodsFor: 'dispatch' stamp: 'cwp 11/30/2012 20:26'!
handleUnprocessableEntity: anError
	^ ALRequest
		status: 422
		reason: 'Unprocessable entity'
		details: anError messageText! !

!ALHttpExceptionRelay methodsFor: 'dispatch' stamp: 'cwp 11/30/2012 20:26'!
handleUnsupportedContentType: anError 
	^ ALResponse 
		status: 415 
		reason: 'Unsupported Content Type'
		details: anError messageText ! !

!ALRelay class methodsFor: 'as yet unclassified' stamp: 'cwp 9/7/2011 15:25'!
destination: aMessageHandler
	^ self basicNew initializeWithDestination: aMessageHandler ! !

!ALRelay class methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 21:15'!
new
	^ self error: 'Use #destination:'! !

!ALRelay methodsFor: 'accessing' stamp: 'cwp 11/24/2012 21:12'!
add: aBlock
	destination := destination add: aBlock.
	^ self! !

!ALRelay methodsFor: 'relaying' stamp: 'cwp 11/24/2012 21:14'!
handleRequest: aRequest
	^ destination handleRequest: aRequest! !

!ALRelay methodsFor: 'initialization' stamp: 'cwp 11/24/2012 21:16'!
initializeWithDestination: aRelay
	self initialize.
	destination := aRelay! !

!ALRelay methodsFor: 'relaying' stamp: 'cwp 11/24/2012 22:08'!
write: aMessage into: aWriteStream
	destination write: aMessage into: aWriteStream! !

Object subclass: #ALResourceQueue
	instanceVariableNames: 'resource queue mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Endpoints'!

!ALResourceQueue class methodsFor: 'as yet unclassified' stamp: 'cwp 10/30/2012 14:50'!
for: anObject
	^ self basicNew initializeWithResource: anObject! !

!ALResourceQueue methodsFor: 'public' stamp: 'cwp 11/24/2012 21:53'!
add: aProcess
	mutex critical: [ queue add: aProcess ]! !

!ALResourceQueue methodsFor: 'public' stamp: 'cwp 11/1/2012 23:22'!
do: aBlock
	| first |
	[mutex critical: [first := queue first].
	first == Processor activeProcess ifTrue:
		[aBlock value: resource.
		mutex critical: [queue removeFirst].
		^ self]]
			repeat.

			! !

!ALResourceQueue methodsFor: 'initialization' stamp: 'cwp 11/1/2012 23:23'!
initializeWithResource: anObject
	self initialize.
	resource := anObject.
	queue := OrderedCollection new.
	mutex := Semaphore forMutualExclusion.! !

Object subclass: #ALServer
	instanceVariableNames: 'state listener application connections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Endpoints'!

!ALServer class methodsFor: 'system startup' stamp: 'cwp 5/4/2011 20:13'!
initialize
	Smalltalk addToStartUpList: self after: AutoStart.
	Smalltalk addToShutDownList: self! !

!ALServer class methodsFor: 'instance creation' stamp: 'cwp 4/23/2011 17:55'!
on: anInteger application: anApplication
	^ self basicNew initializeWithPort: anInteger application: anApplication! !

!ALServer class methodsFor: 'system startup' stamp: 'cwp 5/4/2011 20:57'!
shutDown: aBoolean
	self allInstancesDo: [:ea | ea shutDown]! !

!ALServer class methodsFor: 'system startup' stamp: 'cwp 5/4/2011 20:57'!
startUp: aBoolean
	self allInstancesDo: [:ea | ea startUp]! !

!ALServer methodsFor: 'accessing' stamp: 'cwp 3/6/2012 16:01'!
application
	^ application! !

!ALServer methodsFor: 'private' stamp: 'cwp 10/19/2011 20:35'!
handleConnection: aSocket
	| connection |
	connection := ALConnection socket: aSocket application: application.
	connections add: connection.
	connection start! !

!ALServer methodsFor: 'initialize-release' stamp: 'cwp 10/19/2011 19:55'!
initializeWithPort: anInteger application: anApplication
	self initialize.
	listener := ALListener server: self port: anInteger.
	application := anApplication.
	connections := Set new.
	state := #stopped! !

!ALServer methodsFor: 'testing' stamp: 'cwp 4/13/2011 17:01'!
isRunning
	^ state == #running! !

!ALServer methodsFor: 'printing' stamp: 'cwp 4/13/2011 17:16'!
printOn: aStream
	aStream nextPutAll: (self streamingPrintOn: String new writing)! !

!ALServer methodsFor: 'private' stamp: 'cwp 10/29/2012 00:21'!
purge
	
	(connections reject: [:ea | ea age < 60000 and: [ea isConnected]]) do:
		[:ea |
		ea stop.
		connections remove: ea].! !

!ALServer methodsFor: 'running' stamp: 'cwp 10/19/2011 01:02'!
shutDown
	state == #running
		ifTrue: [ 
			listener shutDown.
			state := #suspended ]! !

!ALServer methodsFor: 'running' stamp: 'cwp 10/19/2011 19:08'!
start
	self isRunning
		ifTrue: [ self stop ].
	state := #running.
	listener start! !

!ALServer methodsFor: 'running' stamp: 'cwp 5/4/2011 20:30'!
startUp
	state == #suspended ifTrue: [self start]! !

!ALServer methodsFor: 'running' stamp: 'cwp 10/27/2012 13:54'!
stop
	listener stop.
	connections do: [:ea | ea stop].
	state := #stopped! !

!ALServer methodsFor: 'printing' stamp: 'cwp 10/19/2011 00:44'!
streamingPrintOn: aWriteStream
	^ aWriteStream
		write: self class name;
		put: $[;
		print: listener port;
		put: $:;
		write: state;
		put: $];
		conclusion! !

Object variableSubclass: #ALStreamable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Core'!

ALStreamable variableSubclass: #ALPath
	instanceVariableNames: ''
	classVariableNames: 'Slash'
	poolDictionaries: ''
	category: 'AL-Http-Core'!

!ALPath class methodsFor: 'as yet unclassified' stamp: 'cwp 3/20/2011 22:57'!
/ aString
	^ self with: aString! !

!ALPath class methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2011 16:16'!
initialize
	Slash := '/'! !

!ALPath class methodsFor: 'dispatch' stamp: 'cwp 10/25/2011 13:45'!
parseWith: aParser
	^ aParser parsePath! !

!ALPath class methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2011 14:31'!
root
	^ self new: 0! !

!ALPath class methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2011 14:48'!
with: aString
	^ (self new: 1)
		at: 1 put: aString;
		yourself! !

!ALPath class methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2011 23:58'!
withAll: segments
	| path |
	path := self new: segments size.
	1 to: path size do: [:index | path at: index put: (segments at: index)].
	^ path! !

!ALPath methodsFor: 'building' stamp: 'cwp 9/13/2011 10:49'!
/ aString
	| path |
	(self isRoot and: [aString isEmpty]) ifTrue: [^ self].
	path := self class new: self size + 1.
	1 to: self size do: [:i | path at: i put: (self at: i)].
	path at: (path size) put: aString.
	^ path! !

!ALPath methodsFor: 'comparing' stamp: 'cwp 3/21/2011 22:20'!
= other
	self species = other species ifFalse: [^ false].
	self size = other size ifFalse: [^ false].
	1 to: self size do: [:i | (self at: i) = (other at: i) ifFalse: [^ false]].
	^ true! !

!ALPath methodsFor: 'converting' stamp: 'cwp 10/9/2012 00:18'!
asPath
	^ self! !

!ALPath methodsFor: 'converting' stamp: 'cwp 7/11/2012 22:57'!
asString
	^ self printString! !

!ALPath methodsFor: 'converting' stamp: 'cwp 10/9/2012 00:17'!
asUrl
	^ ALUrl withPath: self! !

!ALPath methodsFor: 'accessing' stamp: 'cwp 3/11/2011 15:17'!
first
	^ self at: 1! !

!ALPath methodsFor: 'comparing' stamp: 'cwp 3/21/2011 22:22'!
hash
	| hash |
	hash := self class hash.
	1 to: self size do: [:i | hash := hash bitXor: (self at: i) hash].
	^ hash! !

!ALPath methodsFor: 'testing' stamp: 'cwp 3/11/2011 14:54'!
isRoot
	^ self size = 0! !

!ALPath methodsFor: 'accessing' stamp: 'cwp 10/7/2012 23:31'!
path
	^ self! !

!ALPath methodsFor: 'dispatch' stamp: 'cwp 12/22/2012 23:15'!
printWith: aPrinter
	aPrinter printPath: self! !

!ALPath methodsFor: 'accessing' stamp: 'cwp 3/11/2011 15:18'!
rest
	| rest |
	rest := self class new: self size - 1.
	1 to: rest size do: [:index | rest at: index put: (self at: index + 1)].
	^ rest! !

!ALPath methodsFor: 'printing' stamp: 'cwp 9/6/2011 16:15'!
streamingPrintOn: aWriteStream
	self isRoot 
		ifTrue: [aWriteStream write: Slash]
		ifFalse:
			[1 to: self size do:
				[:index |
				aWriteStream write: Slash.
				aWriteStream write: (self at: index)]]! !

!ALStreamable class methodsFor: 'instance creation' stamp: 'cwp 10/4/2012 14:24'!
fromString: aString
	self subclassResponsibility! !

!ALStreamable class methodsFor: 'instance creation' stamp: 'cwp 10/4/2012 14:25'!
ofSize: anInteger
	^ self new: anInteger! !

!ALStreamable class methodsFor: 'streaming' stamp: 'cwp 10/4/2012 14:25'!
writing
	^ XTSequenceableCollectionWriteStream on: self new! !

!ALStreamable methodsFor: 'comparing' stamp: 'cwp 10/7/2012 23:49'!
= other
	self species = other species ifFalse: [^ false].
	self size = other size ifFalse: [^ false].
	1 to: self size do:
		[:index |
		(self at: index) = (other at: index) ifFalse: [^ false]].
	^ true! !

!ALStreamable methodsFor: 'streaming' stamp: 'cwp 10/4/2012 14:24'!
copyFrom: start to: stop 
	"This is copied from SequenceableCollection, so that instances can be created with a writeStream"

	| newSize |
	newSize := stop - start + 1.
	^(self species new: newSize)
		replaceFrom: 1
		to: newSize
		with: self
		startingAt: start! !

!ALStreamable methodsFor: 'streaming' stamp: 'cwp 10/4/2012 14:24'!
grownBy: length
	"This is copied from SequenceableCollection, so that instances can be created with a writeStream"

	| newCollection |
	newCollection := self species ofSize: self size + length.
	newCollection replaceFrom: 1 to: self size with: self startingAt: 1.
	^ newCollection! !

!ALStreamable methodsFor: 'comparing' stamp: 'cwp 10/7/2012 23:53'!
hash
	| hash |
	hash := self class identityHash.
	1 to: self size do:
		[:i | hash := ByteString stringHash: (self at: i) initialHash: hash].
	^ hash! !

!ALStreamable methodsFor: 'printing' stamp: 'cwp 10/4/2012 14:29'!
printOn: aStream
	| ws |
	ws := String new writing.
	self streamingPrintOn: ws.  
	aStream nextPutAll: ws conclusion.! !

!ALStreamable methodsFor: 'printing' stamp: 'cwp 10/4/2012 14:28'!
printString
	^ String new writing
		print: self;
		conclusion! !

!ALStreamable methodsFor: 'streaming' stamp: 'cwp 10/9/2012 00:20'!
reading
	^ XTSequenceableCollectionReadStream on: self! !

!ALStreamable methodsFor: 'streaming' stamp: 'cwp 10/4/2012 14:24'!
replaceFrom: start to: stop with: replacement startingAt: repStart 
	"Uses the Array primitive, so that instances can be created with a writeStream"

	<primitive: 105>
	! !

!ALStreamable methodsFor: 'streaming' stamp: 'cwp 10/7/2012 23:04'!
writing
	^ XTSequenceableCollectionWriteStream on: self! !

ALStreamable variableSubclass: #ALUrl
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Core'!

!ALUrl class methodsFor: 'instance creation' stamp: 'cwp 10/7/2012 22:38'!
/ aString
	^ (self new: 2)
		at: 1 put: $/;
		at: 2 put: aString;
		yourself! !

!ALUrl class methodsFor: 'instance creation' stamp: 'cwp 10/4/2012 14:18'!
fromString: aString
	| ws |
	ws := self writing.
	aString reading percentDecoding streamingWriteInto: ws.
	^ ws conclusion! !

!ALUrl class methodsFor: 'dispatch' stamp: 'cwp 10/4/2012 14:36'!
parseWith: aParser
	^ aParser parseUrl! !

!ALUrl class methodsFor: 'instance creation' stamp: 'cwp 10/7/2012 23:30'!
root
	^ self with: $/! !

!ALUrl class methodsFor: 'instance creation' stamp: 'cwp 10/7/2012 23:30'!
with: anObject
	^ (self new: 1)
		at: 1 put: anObject;
		yourself! !

!ALUrl class methodsFor: 'instance creation' stamp: 'cwp 10/8/2012 00:13'!
withPath: aPath
	| out |
	aPath isRoot ifTrue: [^ self root].
	out := (self new: (aPath size * 2 - 1)) writing.
	1 to: aPath size do:
		[:index |
		out put: $/.
		out put: (aPath at: index)].
	^ out conclusion! !

!ALUrl methodsFor: 'arithmetic' stamp: 'cwp 10/7/2012 23:28'!
/ aString
	| out index token |
	out := (self class new: self size + 2) writing.
	index := 1.
	[(index > self size) or: ['?#' includes: (token := self at: index)]] 
		whileFalse: 
			[out put: token.
			index := index + 1].
	out put: $/.
	out put: aString.
	^ out conclusion! !

!ALUrl methodsFor: 'comparing' stamp: 'cwp 10/7/2012 23:58'!
hash
	"The handling of character tokens is taken from String class>>stringHash:initialHash"

	| hash |
	hash := self class identityHash.
	1 to: self size do: 
		[ :i || token low |
		token := self at: i.
		token isString
			ifTrue: [hash := ByteString stringHash: token initialHash: hash]
			ifFalse: 
				[hash := hash + token asciiValue.
				low := hash bitAnd: 16383.
				hash := (16r260D * low + ((16r260D * (hash bitShift: -14) 
						+ (16r0065 * low) bitAnd: 16383) * 16384)) bitAnd: 16r0FFFFFFF]].
	^ hash! !

!ALUrl methodsFor: 'accessing' stamp: 'cwp 10/7/2012 23:43'!
path
	| in out token seg |
	in := self reading.
	out := ALPath writing.
	seg := String new writing.
	[
		"Skip to the beginning of the path"
		[in get = $/] whileFalse.
		(token := in get) = $/ ifTrue: 
			[[in get = $/] whileFalse.
			token := in get]
			.			
		"Scan through the path"
		['?#' includes: token] whileFalse:
			[token = $/
				ifTrue: 
					[out put: seg conclusion.
					seg := String new writing]
				ifFalse:
					[seg write: token].
		token := in get].
	] on: Incomplete do: [].
	seg position = 0 ifFalse: [out put: seg conclusion].
	^ out conclusion! !

!ALUrl methodsFor: 'dispatch' stamp: 'cwp 12/25/2012 12:40'!
printWith: aPrinter
	aPrinter printUrl: self! !

!ALUrl methodsFor: 'accessing' stamp: 'cwp 12/22/2012 08:24'!
query
	| in out query |
	query := Array new.
	in := self reading ending: $#.
	[ [ in get = $? ] whileFalse ]
		on: Incomplete
		do: [ ^ query ].
	out := query writing.
	^ (ALFormDataParser in: in out: out) parse! !

!ALUrl methodsFor: 'printing' stamp: 'cwp 10/8/2012 14:19'!
streamingPrintOn: anAsciiWriteStream
	| enc |
	enc := anAsciiWriteStream percentEncoding.
	1 to: self size do: 
		[:i || token |
		token := self at: i.
		token ifNotNil:
			[token isString
				ifTrue: [enc write: token]
				ifFalse: [anAsciiWriteStream put: token]]]! !

Object subclass: #ALTerminalRelay
	instanceVariableNames: 'locator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Relays'!

!ALTerminalRelay class methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 21:08'!
locator: aLocator
	^ self basicNew initializeWithLocator: aLocator! !

!ALTerminalRelay methodsFor: 'adding' stamp: 'cwp 11/24/2012 21:11'!
add: aBlock
	^ aBlock value: self! !

!ALTerminalRelay methodsFor: 'relaying' stamp: 'cwp 11/24/2012 21:10'!
handleRequest: aRequest
	^ (locator resourceForUrl: aRequest url) 
		handleRequest: aRequest 
		locator: locator! !

!ALTerminalRelay methodsFor: 'initialization' stamp: 'cwp 11/24/2012 21:09'!
initializeWithLocator: aLocator
	self initialize.
	locator := aLocator! !

!ALTerminalRelay methodsFor: 'relaying' stamp: 'cwp 11/24/2012 22:07'!
write: aMessage into: aWriteStream
	aMessage writeInto: aWriteStream! !

Object subclass: #ALWorker
	instanceVariableNames: 'process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Endpoints'!

ALWorker subclass: #ALConnection
	instanceVariableNames: 'application in queue timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Endpoints'!

!ALConnection class methodsFor: 'as yet unclassified' stamp: 'cwp 4/24/2011 23:17'!
in: aReadStream out: aWriteStream application: anApplication
	^ self basicNew 
		initializeWithIn: aReadStream 
		out: aWriteStream 
		application: anApplication ! !

!ALConnection class methodsFor: 'instance creation' stamp: 'cwp 4/24/2011 23:17'!
socket: aSocket application: anApplication
	^ self in: aSocket reading out: aSocket writing application: anApplication! !

!ALConnection methodsFor: 'accessing' stamp: 'cwp 11/1/2012 22:45'!
age
	^ Time millisecondClockValue - timestamp! !

!ALConnection methodsFor: 'accessing' stamp: 'cwp 11/1/2012 23:05'!
close
	self socket closeAndDestroy! !

!ALConnection methodsFor: 'private' stamp: 'cwp 11/24/2012 21:57'!
handleRequest
	| request dispatch |
	request := ALRequest readFrom: in.
	dispatch := [ self respondTo: request ] newProcess.
	dispatch 
		priority: Processor highIOPriority;
		name: 'dispatch:' , self identityHash printString.
	queue add: dispatch.
	dispatch resume! !

!ALConnection methodsFor: 'initialize-release' stamp: 'cwp 11/1/2012 22:53'!
initializeWithIn: aReadStream out: aWriteStream application: anApplication
	
	self initialize.
	application := anApplication.
	in := aReadStream.
	queue := ALResourceQueue for: aWriteStream.
	self touch
! !

!ALConnection methodsFor: 'testing' stamp: 'cwp 11/1/2012 22:51'!
isConnected
	^ self socket isConnected! !

!ALConnection methodsFor: 'running' stamp: 'cwp 11/1/2012 22:49'!
loop
	[self wait.
	 self handleRequest ] 
		repeat! !

!ALConnection methodsFor: 'accessing' stamp: 'cwp 11/1/2012 23:07'!
name
	| addr socket |
	socket := self socket.
	addr := socket isConnected
		ifTrue: [socket remoteAddress printString]
		ifFalse: ['<closed>'].
	
	^ 'connection: ' , addr! !

!ALConnection methodsFor: 'accessing' stamp: 'cwp 11/1/2012 22:48'!
priority
	^ Processor highIOPriority! !

!ALConnection methodsFor: 'private' stamp: 'cwp 11/30/2012 20:29'!
respondTo: aRequest
	| response handler |
	handler := application createRequestHandler.
	response := handler handleRequest: aRequest.
	(aRequest isConnectionClose or: [response isConnectionClose]) ifFalse:
		[response beConnectionKeepAlive].
	queue do: 
		[ :out | 
		[handler write: response into: out]
			on: Incomplete
			do: [:ignore]].
	self touch! !

!ALConnection methodsFor: 'accessing' stamp: 'cwp 11/1/2012 22:48'!
socket
	^ in terminal! !

!ALConnection methodsFor: 'running' stamp: 'cwp 11/1/2012 22:49'!
tearDown
	self close! !

!ALConnection methodsFor: 'accessing' stamp: 'cwp 11/1/2012 22:45'!
touch
	timestamp := Time millisecondClockValue! !

!ALConnection methodsFor: 'private' stamp: 'cwp 11/1/2012 22:50'!
wait
	
	[self socket waitForDataIfClosed: 
		[ConnectionClosed signal: 'Connection closed.']]
		on: SocketPrimitiveFailed
		do: [:e | .ConnectionClosed signal: 'Connection closed.'].
	self touch! !

ALWorker subclass: #ALListener
	instanceVariableNames: 'server port socket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Endpoints'!

!ALListener class methodsFor: 'as yet unclassified' stamp: 'cwp 10/19/2011 19:05'!
server: aServer port: anInteger
	^ self basicNew initializeWithServer: aServer port: anInteger! !

!ALListener methodsFor: 'private' stamp: 'cwp 10/19/2011 19:07'!
acceptConnection
	| sock |
	sock := socket waitForAcceptFor: self timeout.
	sock ifNotNil: [ server handleConnection: sock ]! !

!ALListener methodsFor: 'initialize-release' stamp: 'cwp 10/19/2011 19:01'!
initializeWithServer: aServer port: anInteger
	self initialize.
	server := aServer.
	port := anInteger! !

!ALListener methodsFor: 'running' stamp: 'cwp 10/19/2011 19:55'!
loop
	[self acceptConnection.
	server purge] 
		repeat! !

!ALListener methodsFor: 'accessing' stamp: 'cwp 11/1/2012 23:08'!
name
	^ 'listener: ', port printString! !

!ALListener methodsFor: 'accessing' stamp: 'cwp 10/19/2011 00:15'!
port
	^ port! !

!ALListener methodsFor: 'accessing' stamp: 'cwp 10/26/2012 23:50'!
priority
	^ Processor lowIOPriority! !

!ALListener methodsFor: 'running' stamp: 'cwp 10/26/2012 23:42'!
setUp
	socket := Socket tcpCreateIfFail: [ self error: 'Unable to create a socket' ].
	socket
		setOption: 'TCP_NODELAY' value: 1;
		setOption: 'SO_SNDBUF' value: 1024;
		setOption: 'SO_RCVBUF' value: 1024;
		listenOn: self port backlogSize: 10.
	socket isValid
		ifFalse: [ self error: 'Unable to listen on port ' , self port printString ]! !

!ALListener methodsFor: 'running' stamp: 'cwp 10/26/2012 23:58'!
tearDown
	socket ifNotNil: 
		[socket closeAndDestroy.
		socket := nil]! !

!ALListener methodsFor: 'accessing' stamp: 'cwp 10/19/2011 00:33'!
timeout
	^ 5! !

!ALWorker methodsFor: 'accessing' stamp: 'cwp 10/27/2012 00:04'!
exceptions
	^ ConnectionClosed! !

!ALWorker methodsFor: 'running' stamp: 'cwp 10/26/2012 23:53'!
loop
	self subclassResponsibility! !

!ALWorker methodsFor: 'running' stamp: 'cwp 10/30/2012 17:44'!
run
	self setUp.
	[[self loop] 
		on: self exceptions
		do: [:e]]
		ensure: 
			[self tearDown.
			process := nil]! !

!ALWorker methodsFor: 'running' stamp: 'cwp 10/26/2012 23:54'!
setUp
! !

!ALWorker methodsFor: 'running' stamp: 'cwp 10/26/2012 23:51'!
shutDown
	process ifNotNil: [ process terminate ]! !

!ALWorker methodsFor: 'running' stamp: 'cwp 10/26/2012 23:52'!
start
	process := [self run] 
		forkAt: self priority 
		named: self name! !

!ALWorker methodsFor: 'running' stamp: 'cwp 10/26/2012 23:52'!
stop
	process ifNotNil: [ process terminate ]! !

!ALWorker methodsFor: 'running' stamp: 'cwp 10/26/2012 23:54'!
tearDown! !

Array variableSubclass: #ALContentTypes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Values'!

!ALContentTypes class methodsFor: 'dispatch' stamp: 'cwp 12/13/2012 22:33'!
parseWith: aParser
	^ aParser parseContentTypes! !

!ALContentTypes methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2012 21:17'!
printWith: aPrinter
	aPrinter printSemicolonSequence: self! !

Array variableSubclass: #ALCookieSpecs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Values'!

!ALCookieSpecs class methodsFor: 'dispatch' stamp: 'cwp 7/12/2012 16:02'!
parseWith: aParser
	^ aParser parseCookieSpecs! !

!ALCookieSpecs methodsFor: 'as yet unclassified' stamp: 'cwp 7/13/2012 13:09'!
asCookieSpecs
	^ self! !

!ALCookieSpecs methodsFor: 'as yet unclassified' stamp: 'cwp 7/13/2012 13:10'!
at: anInteger put: aCookie
	(aCookie isKindOf: ALCookie) ifFalse: [self error: 'Not a cookie'].
	super at: anInteger put: aCookie! !

!ALCookieSpecs methodsFor: 'printing' stamp: 'cwp 7/12/2012 15:42'!
printWith: aPrinter
	aPrinter printCommaSequence: self! !

Array variableSubclass: #ALCookieValues
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Values'!

!ALCookieValues class methodsFor: 'dispatch' stamp: 'cwp 7/12/2012 15:35'!
parseWith: aParser
	^ aParser parseCookieValues! !

!ALCookieValues methodsFor: 'printing' stamp: 'cwp 7/12/2012 15:50'!
printWith: aPrinter
	aPrinter printSemicolonSequence: self! !

Array variableSubclass: #ALStrings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Values'!

!ALStrings class methodsFor: 'as yet unclassified' stamp: 'cwp 12/19/2012 23:04'!
parseWith: aParser
	^ aParser parseStrings! !

!ALStrings methodsFor: 'as yet unclassified' stamp: 'cwp 12/19/2012 23:02'!
printWith: aPrinter
	aPrinter printCommaSequence: self! !

Error subclass: #ALHttpError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Exceptions'!

ALHttpError subclass: #ALMalformedRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Exceptions'!

!ALMalformedRequest methodsFor: 'as yet unclassified' stamp: 'cwp 3/14/2012 13:26'!
handleWith: anObject
	^ anObject handleMalformedRequest: self! !

ALHttpError subclass: #ALMethodNotAllowed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Exceptions'!

!ALMethodNotAllowed methodsFor: 'as yet unclassified' stamp: 'cwp 3/31/2012 20:17'!
handleWith: anObject
	^ anObject handleMethodNotAllowed: self! !

ALHttpError subclass: #ALNotAcceptable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Exceptions'!

!ALNotAcceptable methodsFor: 'as yet unclassified' stamp: 'cwp 3/14/2012 13:26'!
handleWith: anObject
	^ anObject handleNotAcceptable: self.! !

ALHttpError subclass: #ALNotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Exceptions'!

!ALNotFound methodsFor: 'as yet unclassified' stamp: 'cwp 9/11/2008 23:01'!
handleWith: anObject
	^ anObject handleNotFound: self! !

ALHttpError subclass: #ALUnsupportedContentType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Exceptions'!

!ALUnsupportedContentType methodsFor: 'as yet unclassified' stamp: 'cwp 10/14/2011 23:50'!
handleWith: anObject
	^ anObject handleUnsupportedContentType: self! !

Error subclass: #ALParseError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Http-Exceptions'!

!DateAndTime class methodsFor: '*al-http-dispatch' stamp: 'cwp 12/6/2012 15:21'!
parseWith: aParser 
	^ aParser parseDateTime! !

!DateAndTime methodsFor: '*al-http' stamp: 'cwp 12/3/2012 19:29'!
printWith: aPrinter
	^ aPrinter printDateTime: self! !

!Number methodsFor: '*al-http-printing' stamp: 'cwp 10/25/2011 14:59'!
printWith: aPrinter
	aPrinter printNumber: self! !

!ByteArray methodsFor: '*al-http-printing' stamp: 'cwp 10/25/2011 14:22'!
printWith: aPrinter
	aPrinter printBytes: self! !
ALHttpInterpreter initialize!
ALServer initialize!
ALPath initialize!
